/*
* Licensed Materials - Property of IBM
* 5724-U18
* Copyright IBM Corporation. 2016,2019
*/
Polymer({
    is: 'maximo-sr-notfcontainer',
    behaviors: [
        BaseComponent,ServiceRequestBehavior
    ],
    properties: {
        // binding item
        notf: {
            type: Object,
            notify: true,
            reflectToAttribute:true
        }
    },

    ready: function() {
    },

    _onViewTap: function(e) {
        try {
            this.fire('toggle-notf-overlay');
            this.fire('notification-show-sr-details', {notification: this.notf.notfeventmessage});
        } catch(err) {
            this._displayUnexpectedError(err);
        }
    },

    _onReopenTap: function() {
        this.fire('toggle-notf-overlay');
    },

    _formatMessage: function(notificationObj) {
        try {
            var notificationMsg = '';
            switch(notificationObj.status_maxvalue){
                  case 'RESOLVED':
                      notificationMsg = $M.localize('uitext', 'mxapisr', 'ServiceRequestComplete', [notificationObj.ticketid]);
                      break;
                  case 'CLOSED':
                      notificationMsg = $M.localize('uitext', 'mxapisr', 'srstatusclose', [notificationObj.ticketid]);
                      if (notificationObj.status && notificationObj.status === 'CAN') {
                          notificationMsg = $M.localize('uitext', 'mxapisr', 'srstatuscancel', [notificationObj.ticketid]);
                      }
                      break;
                  default:
                      notificationMsg = '';
             }
             return notificationMsg;
        } catch(err) {
            this._displayUnexpectedError(err);
        }
        
    },

    _formatDetails: function(notfeventmessage) {
        var details = notfeventmessage.description;
        return details;
    },

    // use locale stored in user's profile or browser language
    _formatDate: function(timestamp) {
        try {
            var user = $M.getUserInfo();
            var date = new Date(timestamp)
            if (user.defaultLcale){
                return date.toLocaleDateString(user.defaultLcale.replace('_','-'));
            } else {
                return date.toLocaleDateString();
            }
        } catch(err) {
            this._displayUnexpectedError(err);
        }
    	
    },

    // highlight unread
    _highlight: function(touched) {
        if (!touched) {
            return 'unread';
        };
    }
});
