/*
 * @license
 * Licensed Materials - Property of IBM
 * 5724-U18
 * Copyright IBM Corporation. 2016, 2018
 */
 
/*
The `maximo-context` element provides access to context data associated with the current user,
current application and lot of utility methods. The maximo-context component is instantiated 
and stored in a global variable called `$M` that is accessible to all code and any component. 

*/
String.prototype.bool = function() {
    return (/^true$/i).test(this.toLowerCase());
};

/*
The `maximo-context` element provides access to context data associated with the current user,
current application and lot of utility methods. The maximo-context component is instantiated 
and stored in a global variable called `$M` that is accessible to all code and any component. 

*/

Polymer({
	is: 'maximo-context',
	dir: '',
	workScape: null,
	orientation : 'portrait',
	carouselMax : 6,
	_designMode: false,
	scroll: true,
	bodyScroll: 0,
	behaviors: [Formatter, DisableBehavior, HTMLEncoder],
	messageBundles: {},
	maximoComponentsList: {},
	unloadedBundles : {},
	currentWorkscape: '',
	_configLabels: 'mxapicomponent',
	newWorkscape: '',
	wizardStep: '',
	allowedWorkscapes: null,
	lockWait: false,
	_refreshTime: 0,
	history: {
		map: {},
		stack: []
	},
	_blockWait: false,
	unregisteredApps: ['test','welcome','test1','test2'],
	keyCode: {
		'DELETE'	: 46,
		'DOWN'		: 40,
		'ENTER'		: 13,
		'ESCAPE'	: 27,
		'LEFT'		: 37,
		'RIGHT'		: 39,
		'SPACEBAR' 	: 32,
		'UP'		: 38,
		'BACKSPACE'	: 8,
		'TAB'		: 9,
		'COMMA'     : 188,
		'PERIOD'    : 190
	},
	listeners: {
		'workcenter-ready' : '_workcenterReady',
		'designer-toggle-design-mode' : '_toggleDesignMode',
		'design-mode-changed' : '_designModeChanged',
		'designer-pause': '_pauseDesignMode',
		'show-user-tour':'_showUserTour'
	},
	properties: {
		requiredResources: {
			type: Array,
			value: function() {
				return null;
			},
			observer: '_loadResources'
		},
		debug: {
			type: Boolean,
			value: false
		},
		demo: {
			type: Boolean,
			value: false
		},
 	  	notifications : {
	  		type: Object,
	  		value: function(){
	  			return {'map':{},'stack':[]};
	  		}
	  	},
	  	userInfo: {
	  		type: Object,
	  		value: function(){
	  			return {};
	  		}
	  	},
	  	_changedToWC: {
	  		type: String,
	  		value: ''
	  	},
	  	_BotC: {
	  		type: Boolean,
	  		value: false,
			observer: '_notifyWorkCenter'
	  	},
	  	_tpaeLoaded: {
	  		type: Boolean,
	  		value: false,
			observer: '_tpaeLoadChange'
	  	},
	  	_demoUser: {
	  		type: Boolean,
	  		value: false
	  	},
	  	_isFirstAdminVisit: {
	  		type: Boolean,
	  		value: null
	  	},
	  	_lookups: {
	  		type: Object,
	  		value: {}
	  	},
	  	_xPublicUri: {
	  		type: String,
	  		value: ''
	  	},
	  	_analyticsEnabled: {
	  		type: Boolean,
	  		value: false
	  	},
	  	/*
	  	 * _userToursVisited contains an array of the apptracker data of which tours have been viewed by this user
	  	 * sessionStorage["application-tours"] contains the actual tour information for each tour retrieved
	  	 */
	  	_userToursVisited: {
	  		type: Array,
	  		value: function(){
	  			return new Array();
	  		}
	  	},
		_eventSubscribers: {
			type: Object,
			value: {}
		},

		/*
		 * Default tour for workcenter
		 */
		_showDefaultTour: {
			type: Boolean,
			value: false
		},
		/*
		 * User geolocation
		 */
		_currentCoordinates: {
			type: Object,
			value: null
		},
		
		/**
    	 * Interval in seconds to 
    	 * undo delete operation
    	 */
    	undoIntervalSecs: {
    		Type: Number,
    		value: 3
		},
		/**
    	 * Default for tour disabled  
    	 */
		isTourDisabled: {
			type : Boolean,
			value : false
		},
		/**
    	 * Default for show tour manually  
    	 */
		showTourManual: {
			type : Boolean,
			value : false
		},

    /**
     * 
     */
    _apikey: {
      type: String,
      value: ''
    },

    /**
     * 
     */
    _guestID: {
      type: String,
      value: ''
    }
	},
    observers: [
		'_workCenterChanged(routeData.workcenter)',
		'_subRouteChanged(subroute)'
	],
	
	/*
	 * Are we in design mode?
	 */
	inDesignMode: function(){
		return this._getSessionDesignMode();
	},
	
	hasPopupHash: function(){
		var hashArray = window.location.hash.split('/');
		var lastHashPart = parseInt(hashArray.pop());
		return !isNaN(lastHashPart);
	},
	
	getApiCacheKey: function(){
		return sessionStorage.getItem('apicachekey');
	},
	
	setApiCacheKey: function(apicachekey){
		sessionStorage.setItem('apicachekey', apicachekey);
	},
	
	getMaxauth: function(){
		var maxauth = JSON.parse(sessionStorage.getItem('maxauth'));
		if(!maxauth){
			maxauth = {};
			sessionStorage.setItem('maxauth',JSON.stringify(maxauth));
		}
		return maxauth;
	},
	setMaxauth: function(maxauth){
		if(maxauth.whoami){
			this._BotC = maxauth.whoami.botcinstall!==undefined?maxauth.whoami.botcinstall:false;
			this._demoUser = maxauth.whoami.demouser!==undefined?maxauth.whoami.demouser:false;
			if(this._isFirstAdminVisit===null){
				this._setFirstAdminVisit(maxauth.whoami);
			}
		}
		sessionStorage.setItem('maxauth', JSON.stringify(maxauth));
		this.maxauth = maxauth;
	},
	addToMaxauth: function(key, object){
		if(key && object){
			var maxauth = this.getMaxauth();
			maxauth[key] = object;
			this.setMaxauth(maxauth);
		}
	},
	lastLogout: function(){
		return this.userInfo.user.logouttracking.attemptdate;
	},
	pushState: function(undoAction){
		this.history.stack.push(undoAction);
		undoAction.index = this.history.stack.length;
		this.history.map[undoAction.id] = undoAction;
		this.currentHash = undoAction.index;
		if(undoAction.index === 1 && !this.hasPopupHash()){
			this.setPopHash(0, true);
		}
		this.async(function(){
			if(!this.hashCheck){
				this.hashHandler = function(){
					var hashArray = window.location.hash.split('/');
					var lastHashPart = parseInt(hashArray.pop().replace(/#/,''));
					var newHash = lastHashPart; 
					if(!isNaN(lastHashPart)){
						if($M.lastHash>newHash){//back
							$M.popState();
							$M.currentHash--;
						}
						$M.lastHash = newHash;
					}
					$M.useHash = true;
				};
				this.hashCheck = window.addEventListener('hashchange', this.hashHandler, false);
			}
			this.setPopHash(undoAction.index);

		}, 100);
	},
	popState: function(){
		var undoAction = this.history.stack.pop();
		if(undoAction){
			delete this.history.map[undoAction.id];
			if(undoAction.element.closeMe){
				undoAction.element.closeMe(this);
			}
			else if(undoAction.element.popMe){
				undoAction.element.popMe();
			}
		}
		if(this.history.stack.length === 0){
			window.removeEventListener('hashchange',this.hashHandler);
			this.setPopHash(-1);
			this.hashCheck = null;
		}
	},
	setPopHash: function(index, force){
		var hash = '';
		var hashArray = window.location.hash.split('/');
		var lastHashPart = hashArray[hashArray.length-1];
		var lastHash = parseInt(lastHashPart.replace(/#/g,'')); 
		if(!isNaN(lastHash)){
			hashArray.pop();//remove previous numeric if there was one.
		}
		hashArray.forEach(function(hashPart){
			if(hashPart !== ''){
				hash += hashPart + '/';
			}
		});
		window.location.hash = hash + (force || index>=0?index:'');
	},
	_wasRefreshed: function(){
		if (window.performance) {
      		var hashOverride = sessionStorage.getItem('hashOverride');
      		return !hashOverride && performance.navigation.type === 1;
		}
		return false;
	},
	setWCContext: function(wcContext){
		if(wcContext && typeof wcContext === 'string'){
			sessionStorage.setItem('wcContext', wcContext);
		}
		else {
			sessionStorage.removeItem('wcContext');
		}
	},
	_workCenterChanged: function(workCenter) {
		if((!this._wasRefreshed() || (this._refreshTime < (new Date()).getTime() - 1000))  && $M.getMaxauth() && $M.getMaxauth().whoami && (this.routeWorkCenter === undefined || workCenter !== this.routeWorkCenter)){
			if(workCenter && workCenter !== '' && workCenter !== this.currentWorkscape){
				this.routeWorkCenter = workCenter;
				$M.toggleWait(true);
				if($M.hasAccessToWorkscape(workCenter)){
					$M.loadWorkscape(workCenter);
				}
				else {
					$M.set('route.path', '/'+this.currentWorkscape);
					if(this.currentWorkscape !== ''){
						this.async(function(){
							$M.alert($M.localize('uitext','mxapibase','no_access')+ ' ['+workCenter+']');	
						});
					}
				}
			}
		}
		if(this._wasRefreshed()){
			this._refreshTime = (new Date()).getTime();
		}
	},
	_subRouteChanged: function(subroute){
		if(subroute !== undefined && subroute !== this.subRoute && this.workScape){
			if(subroute !== this.workScape.get('subroute')){
				this.applySubRoute(subroute);
			}
			this.subRoute = subroute;
		}
	},
	getSubRoute: function(){
		var path = this.subroute.path;
		if(!path){
			path = '';
		}
		if(path.startsWith('/')){
			path = path.substring(1);
		}
		return path;
	},
	setSubRoute: function(path){
		if(!path){
			path = '';
		}
		if(path.startsWith('/')){
			path = path.substring(1);
		}
		this.setHash('#/'+$M.currentWorkscape+'/'+path);
	},
	setHash: function(hash){
	    if (navigator.userAgent.includes('WebKit')) {
	    	//webkit on ipad does not respond to window.location.hash so we can always use window.location.href for webKit
	    	window.location.href = hash;
	    } 
	    else {
	    	window.location.hash = hash;	        
	    }
	},
	applySubRoute: function(subroute){
		if(this.workScape && subroute !== this.workScape.get('subroute')){
			if(subroute !== this.workScape.get('subroute')){
				this.workScape.set('subroute', subroute);
			}
			if(this.workScape.domHost && subroute !== this.workScape.domHost.get('subroute')){
				this.workScape.domHost.set('subroute', subroute);	
			}
			//support subroute on all maximo-navbars
			$j('maximo-navbar').each(function(){
				if(this.subRoute === true){
					this.set('subroute', subroute);
				}
			});
		}
	},
	alerts : {
		info : 0,
		warn : 1,
		error : 2,
		question: 3,
		warninfo: 4
	},
	notificationPos : {
		x : 'center',
		y: 'top'
	},
	lang: 'en',
	country: 'US',
	screenInfo : {},
	notificationtimeout : 3,
	undoNotificationtimeout: 3,
	underlays : [],
	components: {},
	elementCounts: {},
	collections: {
		//each collection will register itself to send / listen for refresh events
	},
	overlayDialogs: [],
	dialogs: {
		map: {},
		stack: []
	},
	colorPalleteRGB : ['#5596E6','#7CC7FF','#5AA700','#B4E052','#00B4A0','#6EEDD8','#A6266E','#FF9EEE','#FF5003','#FFA573','#6D7777','#C7C7C7','#FDD600'],
	fixUnderlays: function(){
		var underlayLength = this.underlays.length;
		this.underlays.forEach(function(underlay, index){
			$j(underlay).css({'opacity':index+1 === underlayLength?'.2':'0'});
			$j(underlay.nextElementSibling).toggleClass('song2', false);
		});

	},
	registerCollection: function(id, events){
		var existing = $M.collections[id];
		if(!existing){
			$M.collections[id] = {events:[]};
		}
		events.forEach(function(event){
			$M.addCollectionListener(id, event);
		});
	},
	addCollectionListener : function(id, event){ // id is id of collection
		if(!$M.collections[id]){
			$M.registerCollection(id, [event]);
			return;
		}
		if(!this.arrayContains($M.collections[id].events, event)){
			$M.collections[id].events.push(event);
		}
	},
	removeCollectionListener : function(id, event){ // id is id of collection
		if($M.collections[id]){
			this.arrayRemove($M.collections[id].events, event);
		}
	},
	notifyCollections: function(id){
		var collection = $M.collections[id];
		var self = this;
		if(collection){
			var notified = [];
			var events = collection.events;
			events.forEach(function(event){
				Object.keys($M.collections).forEach(function(key){
					if(key !== id && !self.arrayContains(notified, key)){//don't refresh original collection or one that we have previously refreshed by this process
						var refresh = $M.collections[key];
						if(self.arrayContains(refresh.events, event)){
							var refreshCollection = window[key];
							notified.push(key);
							if(refreshCollection && refreshCollection.length){ //in case of duplicate IDs - TODO - this should come out after ID restrictions are resolved
								[].forEach.call(refreshCollection, function(child) {
									$j.proxy(child.refreshRecords(null,true), child);
								});
							}
							else {
								$j.proxy(refreshCollection.refreshRecords(null,true), refreshCollection);
							}
						}
					}
				});
			});
		}
	},

	/**
   * Make sure the component reference 
   * gets deleted in components object
   * # 322768
   * @param {*} component 
   */
  removeComponent: function(component) {
    try {
      component.componentRegistered = false;
      if (component.id) {
        delete this.components[component.id]
      }
    } catch (error) {
      console.error(`Logging error while removing component ${component.id}`);
    }
  },

	addComponent: function(component){
		var nodeName = component.nodeName.toLowerCase();
		component.componentRegistered=true;
		if(this.components[component.id] && component._templateInstance){
			if(component._templateInstance._rootDataHost){
				component.id = component._templateInstance._rootDataHost.id + component.idSep +component.id;
				component.modifiedId = true;
			}
		}
		var parentComponent = null;
		if(component.parentNode){
			if((component.parentNode !== component.parentElement && component.parentNode.host)){
				parentComponent = component.parentNode.host;
			}
			else if(this.elementCounts[component.parentNode.nodeName.toLowerCase()]){
				parentComponent = component.parentNode;
			}
		}
		try {
			if(this.debug || this.demo){
				if(!component.id || component.missingId){
					throw 'No id defined for ';
				}
			}
		}
		catch (error){
			var info = ' ';
			Object.keys(component.attributes).forEach(function(key){
				var attribute = component.attributes[key];
				if(attribute.name !== 'class'){
					info+= attribute.name+'="'+attribute.value+'" ';
				}
			});
			var errorString = '';
			switch(error){
				case 'missing':
					errorString = 'No id defined for ';
					break;
				case 'duplicate':
					break;
			}
			console.error(error +'<'+ nodeName + info +'>. ');// + host);
		}
		finally {
			this.components[component.id] = component;
			var nodeCount = parseInt(this.elementCounts[nodeName]);
			if(isNaN(nodeCount)){
				nodeCount = 0;
				this.elementCounts[nodeName] = ++nodeCount;
			}
		}
	},
	pre : function(){
		this._setLocale(navigator.language || navigator.browserLanguage);
		this.pageName = location.pathname.substring(location.pathname.lastIndexOf('/') + 1);
		if(window.$j){
			console.error('jQuery already initialized');
		}
		window.$j = jQuery.noConflict();
		if(window.$M){
			console.error('maximo-context is a singleton and has already been initialized.');
		}
		else {
			window.$M = this;
		}
		var context = this;
		this.async(function(){
			context.getOrientation();
		}, 100);

		$j(window).scroll(function(event) {
			if(context.scroll===false){
				//scrollValue will be set as bodyScroll if it have value other than 0, else it will use window scrollTop
				var scrollValue = context.bodyScroll ? context.bodyScroll : $j(window).scrollTop();
				$j(window).scrollTop(scrollValue);
			}
		});
		
		$j('body').on('useractivity', function(){
			this.login._startInactivityTimer();
		});
	},
	created: function(){
		try {$.ajaxSetup({xhrFields: { withCredentials: true } });}catch(error){}
		this.pre();
		if(!sessionStorage.getItem('resources')){
			sessionStorage.setItem('resources', JSON.stringify({'strings':{}}));
		}

		this.maximoProperties = JSON.parse(sessionStorage.getItem('maximoProperties'));
		this.touch = this.maximoProperties.touch;
		this.mock = this.maximoProperties.mock;
		this.debug = this.maximoProperties.debug;
		this.logLevel = this.maximoProperties.logLevel;
		this.markPolymerListeners = this.maximoProperties.markPolymerListeners;
		this.skin = this.maximoProperties.skin;
		if(this.dir===''){
			this.dir = this.maximoProperties.dir?this.maximoProperties.dir:'ltr';
		}
		this.carousel = this.maximoProperties.carousel;
		document.dir = this.dir;
		if(this.dir === 'rtl'){
			this.skin+=' rtl';
		}
		try{
			this.touch = ('ontouchstart' in window || navigator.msMaxTouchPoints);
			this.click = true;
			if(this.touch){ // todo - seems to now be broken in chrome desktop
				if(!document.documentElement.click){
					this.skin+=' touch';
				}
			}
			/* Make scrollbars visible on webkit
			 * Body will not show a scrollbar on mobile
			 * internal scrollable areas will
			 */ {
				var touchStyle = document.createElement('style');
				var cssLocation = 'css/touch.css';
				var pathDiff = location.pathname.length - location.pathname.replace(/\//g, '').length;
				if(pathDiff > 2){
					if($M.debug){
						console.info('Not loading from the webcontent root. Modifying touch css path.');
					}
					do{
						cssLocation = '../'+cssLocation;
						pathDiff--;
					}
					while(pathDiff > 2);
				}
			    $j.get(cssLocation, function(css){
			    	$M.scrollSize = $M.touch?'4':'8';
		    		css = css.replace(new RegExp('{scroll-size}', 'g'), $M.scrollSize);
		    		css = css.replace(new RegExp('{thumb-color}', 'g'), $M.touch?'rgba(0, 0, 0, .3)':'rgba(0, 0, 0, .08)');
		    		css = css.replace(new RegExp('{track-color}', 'g'), $M.touch?'rgba(0, 0, 0, .08)':'transparent');
		    		touchStyle.appendChild(document.createTextNode(css));
		    		document.head.appendChild(touchStyle);
			    });
			}

		}
		catch(e){
			//not touch!
		}
	},
	scrollTo: function(x,y){
		var scroll = this.scroll;
		this.scroll = true;
		window.scrollTo(x,y,'instant');
		this.async(function(){
			this.scroll = scroll;//set it back	
		},10);
	},
	getDefaultBaseApplicationId: function(logical){
		return this.getDefaultApplicationId(logical, true);	
	},
	getDefaultApplicationId: function(logical, baseOnly){
		var defaultApp = 'startcntr';
		if(this.isBotC()){ //337220
			defaultApp = 'welcome';
		}

		var maxauth = this.getMaxauth();
		if(maxauth){
			if(this._isFirstAdminVisit){
				defaultApp = 'welcome';
			}
			else{
				var whoami = maxauth.whoami;
				if(whoami && whoami.defaultApplication && whoami.defaultApplication.length > 0){
						defaultApp = whoami.defaultApplication;
				}
			}
		}
		return defaultApp;
	},
	
	/**
	 * Get localized version of true/false
	 */
	getLocalizedBoolean : function(bool){
		var maxauth = this.getMaxauth();
		var whoami = maxauth.whoami;
		return (bool===true) ? whoami.displayyes : whoami.displayno;
	},
	
	getApplication: function(id){
		var maxauth = this.getMaxauth();
		if(maxauth){
			var whoami = maxauth.whoami;
			if(whoami){
				if(whoami.workcenters[id.toLowerCase()]){
					return whoami.workcenters[id.toLowerCase()];
				}
				if(whoami.applications[id]){
					return whoami.applications[id];
				}
			}
		}
		return null;
	},
	
	attached: function(){
		var istourdisabled = JSON.parse(sessionStorage.getItem('istourdisabled'));
		if(!istourdisabled){
			sessionStorage.setItem('istourdisabled', JSON.stringify([]));
		}
		
		this.$.alert.className = this.$.alert.className +' '+this.dir;
		var context = this;
		window.addEventListener('message', function(e){
			if(e.data['ui-sessionid']){
				context._setUISessionID(e.data['ui-sessionid']);
			}
			if(e.data['app-title']){
  				context._setMaximoAppTitle(e.data['app-title'])
  			}
			if(e.data['inner-app-lost-session']){
  				context._iframeLostSession();
  			}
			if(e.data['inner-app-ready']){
  				context._tpaeLoaded = e.data['inner-app-ready'];
  			}
			if(e.data['inner-app-saved']){
	  			context.publishEvent('inner-app-saved', e.data['inner-app-saved']);
	  		}
			if(e.data['inner-app-notification']){
	  			context.notifyWithCustomTimeout(e.data['inner-app-notification'], context.alerts.info, 3);
	  		}
  			if(e.data['maximo-app-notification']){
  				if(e.data['maximo-app-notification'] === 'contains-errors'){
  					$M.toggleWait(false);
  					$M.notifyWithCustomTimeout(workscape.localize('uitext', 'mxapibase', 'tpae_contains_errors', [$M.workScape.label]), $M.alerts.warn, 7);
  				}
  				else if(e.data['maximo-app-notification'] === 'tpae-save-option'){
  					var message = workscape.localize('uitext', 'mxapibase', 'tpae_save_option', [$M.workScape.label, $M.workScape._breadCrumb.WorkCenter.title]);
  					$M.toggleWait(false);
  					$M.confirm(message, function(response, e){
  						if(response === true){
  							context.workScape.$.maximoIframe.contentWindow.postMessage({'save-tpae':true},'*');
  						}
  					}, this, 1, [0,1]);

  				}
  				else { //message defined by inner app
  					$M.toggleWait(false);
  					$M.notifyWithCustomTimeout(e.data['maximo-app-notification'], $M.alerts.warn, 7);
  				}
  			}
			else if(e.data['close-tpae-iframe']){
				context._tpaeLoaded = false;
				workscape._closeTpaeApplication();
			}
		}, false);
	}, 
	
	/**
	 * To show overlay based on condition whether create or question
	 * 
	 * @param toOverlay element to which overlay showld apply 
	 * @param message Message String Text for Overlay.
	 * @param createObj Object for createoverlay with create specific attributes
	 * @param questionObj Object for questionoverlay with question specific attributes
	 * @param displayVertical Boolean true/false - Show vertical(true) / horizontal (false)
	 * @param scroller
	 * @param actions
	 */
	showOverlay(toOverlay, message, createObj, questionObj, displayVertical, scroller, actions,overlayId) {
		var css, attributes, remove, completeTimer;
		var id = $j(toOverlay).attr('original-id');
		if (toOverlay.id) {
			id = toOverlay.id;
		}
		
		if(overlayId){
			id =overlayId;
		}
		
		var overlay = Polymer.Base.create('div', {'id':'overlay'+id, 'align': 'center'});
		overlay.style.background = '#FFFFFF';
		overlay.style.opacity = 0.93;
		overlay.style.position = 'absolute';
		overlay.style.zIndex = 999;
		overlay.style.height = '0px';
		overlay.style.display='flex';
		overlay.style.flexDirection='row';
		
		var overlayChild = Polymer.Base.create('div', {'id':'overlayChild'+id});
		overlayChild.setAttribute('class','overlayChild');
		overlayChild.style.display='flex';
		overlayChild.style.flexDirection='column';
		overlayChild.style.width='100%';
		overlayChild.style.justifyContent='center';
		overlayChild.style.alignItems='center';  
		
		var overlayMessage = Polymer.Base.create('MAXIMO-LABEL', {'id':'overlayMessage'+id,'label':message,'style':'font-size:22px'});		
		overlayMessage.$.label.id='label_message_'+'overlayMessage_'+id;
		
		overlay.style.overflow = 'hidden';
		overlay.style.transition =  'height .3s';		
		
		if(!scroller){
			scroller = window;
		}
		
		if (toOverlay) {
			overlay.style.top = parseInt(toOverlay.offsetTop)+'px';
			overlay.style.left = parseInt(toOverlay.offsetLeft)+'px';
			overlay.style.width = parseInt(toOverlay.clientWidth)+'px';
			
			if (toOverlay.children[0] && toOverlay.tagName !== 'TR'){
				toOverlay.insertBefore(overlay, toOverlay.children[0]);
			} else {
				toOverlay.appendChild(overlay);
			}				
			overlay.style.height = parseInt(toOverlay.clientHeight)+'px';				
			toOverlay.overlay  = overlay;
		}
		
		if(scroller){
			$j(overlay).css({'margin-top':'-'+scroller.scrollTop+'px','margin-left':'-'+scroller.scrollLeft+'px'});
			overlay.scrollHandler = $j(scroller).on('scroll', function(){
				if(scroller){
					$j(overlay).css({'margin-top':'-'+scroller.scrollTop+'px','margin-left':'-'+scroller.scrollLeft+'px'});
				}
			});
		}
		
		if(questionObj && questionObj !== ''){ // If Object is of question overlay
			$j(overlayMessage).attr('use-path-id','true');
			var buttonlayer = Polymer.Base.create('div', {'id':'buttonlayer'+id, 'align': 'center'});
			buttonlayer.style.zIndex = 1000;
			buttonlayer.style.width = '100%';
			
			if(displayVertical){ //vertical layout
				buttonlayer.style.display = 'auto';
				buttonlayer.style.padding = '10px 0px 0px 0px';
				buttonlayer.style.justifyContent= 'center';
				overlayChild.style.justifyContent='space-evenly';
			} else { //horizontal layout
				buttonlayer.style.display = 'flex';
				buttonlayer.style.justifyContent='space-evenly';
				buttonlayer.style.paddingTop = '10px';
			}	
			
			var overlayButtonOne = Polymer.Base.create('MAXIMO-BUTTON', {'id':'overlayButtonOne'+id,'label':questionObj.buttonOneText,'style':'color:#4178BE;font-size:17px;cursor:pointer','use-path-id':'true','action':'true'});
			overlayButtonOne.$.button.id='label_question_'+'overlayButtonOne_'+id;
			
			var overlayButtonTwo = Polymer.Base.create('MAXIMO-BUTTON', {'id':'overlayButtonTwo'+id,'label':questionObj.buttonTwoText,'style':'font-size:20px;cursor:pointer','use-path-id':'true'});
			overlayButtonTwo.$.button.id='label_question_'+'overlayButtonTwo_'+id;
			overlayButtonTwo.$.button.style.width='100px';
			
			if(questionObj.message && questionObj.message!==''){
				overlayChild.appendChild(overlayMessage);
				overlayChild.appendChild(Polymer.Base.create('br', {}));
			}		
			
			if(questionObj.buttonOneIcon){
				this._generateButton('buttonOne', questionObj.buttonOneIcon, questionObj.buttonOneText, overlayChild, id, questionObj.buttonOne, remove, overlay, toOverlay, buttonlayer,displayVertical);
			}
		
			if(questionObj.buttonTwoIcon){
				this._generateButton('buttonTwo', questionObj.buttonTwoIcon, questionObj.buttonTwoText, overlayChild, id, questionObj.buttonTwo, remove, overlay, toOverlay, buttonlayer,displayVertical);
			}
			
			overlay.close = function(){
				overlay.remove();
				buttonlayer.remove();
				toOverlay.overlay  = null;
				$M.unsubscribe('reset-workcenter', overlay);
			};
			
			overlay.resizeHandler = $j(window).on('resize', function(){
				window.setTimeout(function(){
					overlay.style.height = parseInt(toOverlay.clientHeight)+'px';
					overlay.style.width= parseInt(toOverlay.clientWidth)+'px';					
					if(questionObj.buttonOneIcon || questionObj.buttonTwoIcon){
						buttonlayer.style.height = parseInt(toOverlay.clientHeight)+'px';
						buttonlayer.style.width= parseInt(toOverlay.clientWidth)+'px';
					}
				}, 300);
			});
			
			$j(overlay).on('reset-workcenter', function(e){
				overlay.close();
			});
			
			if (questionObj.showCancel && questionObj.showCancel===true){
				var cancelButtonDiv = Polymer.Base.create('div', {'id':'cancelButtonDiv'+id});
				cancelButtonDiv.style.width='97%';
				cancelButtonDiv.style.paddingTop='20px';
												
				var cancelButton = Polymer.Base.create('maximo-button', {'id':'cancelButton'+id, 'icon':'Maximo:Close', 'label':$M.localize('uitext', 'mxapibase', 'Cancel')});
				cancelButton.action='action';
				cancelButtonDiv.appendChild(cancelButton);
							
				cancelButton.addEventListener('click', function(e) {
					overlay.close();
				});				
			}

			if(actions){
				overlayChild.appendChild(actions); //custom actions provided by the caller
				actions.addEventListener('click', function(e) {
					if(remove === undefined || remove === true){
						overlay.close();
					}
					if (questionObj.buttonTwo) {
						buttonTwo();
					}
					if (questionObj.buttonOne) {
						buttonOne();
					}
				});
			} else {
			
				if(!questionObj.buttonOneIcon){
					var overlayButtonDiv = Polymer.Base.create('div', {'id':'overlaybuttondiv'+id,'class':'overlaydiv','align': 'flex-equal-around-justified'});
					overlayButtonDiv.style.paddingTop = '10px';
					overlayButtonDiv.style.display = 'flex';
					overlayButtonDiv.style.justifyContent = 'space-evenly';
					
					overlayButtonDiv.style.whiteSpace = '';
					
					overlayButtonDiv.appendChild(overlayButtonOne);
					overlayButtonDiv.appendChild(overlayButtonTwo);

					this._registerButtonListener(overlayButtonOne,questionObj.buttonOne,remove,overlay,toOverlay,buttonlayer);
					this._registerButtonListener(overlayButtonTwo,questionObj.buttonTwo,remove,overlay,toOverlay,buttonlayer);
				
					overlayChild.appendChild(overlayButtonDiv);
				}
			}	
			overlayChild.appendChild(buttonlayer);
			
			if (questionObj.showCancel && questionObj.showCancel===true){
				overlayChild.appendChild(cancelButtonDiv);
			}
		
			overlay.appendChild(overlayChild);
		
			if (toOverlay) {
				if(questionObj.buttonOneIcon || questionObj.buttonTwoIcon){
					buttonlayer.style.top = parseInt(toOverlay.offsetTop)+'px';
					buttonlayer.style.left = parseInt(toOverlay.offsetLeft)+'px';
					buttonlayer.style.width = parseInt(toOverlay.clientWidth)+'px';
				}		
			}
			
			this.async(function(){
				overlay.close();
			}, 5000);
			$M.subscribe('reset-workcenter', overlay);		
		} else if(createObj){  // If Object is of create overlay with undo
			var noBR = createObj.noBR; 
			var timer = createObj.timer;
			
			if(createObj.timer !== null && typeof createObj.timer === 'object'){
				scroller = createObj.timer.scroller;
				actions = createObj.timer.actions;
				noBR = createObj.timer.noBR;
				css = createObj.timer.css;
				attributes = createObj.timer.attributes;
				remove = createObj.timer.remove;
				timer = createObj.timer.timer;
			}
			
			if (createObj.classStyle) {
				overlay.classList.add(createObj.classStyle);
			}
			
			var overlayButton = Polymer.Base.create('MAXIMO-BUTTON', {'id':'overlayButton'+id, 'icon':'Maximo:Reset','action':true, 'label':this.localize('uitext', 'mxapibase', 'Undo'),'style':'font-size:20px;color:#4178BE'});
			overlayButton.$.button.id='label_'+'overlayButton'+id;

			overlayChild.appendChild(overlayMessage);
			if (createObj.noBR === undefined || createObj.noBR === false){

			}
			
			//fire callback right away and remove overlay
			if(timer===null){
				overlay.remove();
				if (createObj.completeCallback) {
					createObj.completeCallback(toOverlay);
				}
				return;
			}
			
			if(actions){
				overlayChild.appendChild(actions); //custom actions provided by the caller
				actions.addEventListener('click', function(e) {
					if(remove === undefined || remove === true){
						overlay.remove();
						toOverlay.overlay  = null;
					}
					if (completeTimer) {
						window.clearTimeout(completeTimer);
					}
					if (createObj.undoCallback) {
						createObj.undoCallback();
					}
				});
			} else {
				var overlayButtonDiv = Polymer.Base.create('div', {'id':'overlaybuttondiv'+id,'class':'overlaydiv','align': 'center'});
				overlayButtonDiv.style.paddingTop = '10px';
				overlayButtonDiv.style.cursor = 'pointer';
				overlayButtonDiv.style.width = '120px';
				if (noBR){
					overlayButtonDiv.style.display = 'inline-block';
					overlayButtonDiv.style.whiteSpace = 'nowrap';
					overlayButtonDiv.style.padding = '0px 20px 0px 20px';
					overlayChild.style.flexDirection='row';
				}
				overlayButtonDiv.appendChild(overlayButton);
				overlayButtonDiv.addEventListener('click', function(e) {
					if(remove === undefined || remove === true){
						overlay.remove();
						toOverlay.overlay  = null;
					}
					if (completeTimer) {
						window.clearTimeout(completeTimer);
					}
					if (createObj.undoCallback) {
						createObj.undoCallback();
					}
				});
				overlayChild.appendChild(overlayButtonDiv);
			}
			overlay.appendChild(overlayChild);
			overlay.resizeHandler = $j(window).on('resize', function(){
				window.setTimeout(function(){
					overlay.style.height = parseInt(toOverlay.clientHeight)+'px';
					overlay.style.width= parseInt(toOverlay.clientWidth)+'px';
				}, 300);
			});
			
			if (timer) {
				completeTimer = window.setTimeout(function() {					
					overlay.remove();
					overlay.scrollHandler.off();
					overlay.resizeHandler.off();
					if (createObj.completeCallback) {
						createObj.completeCallback(toOverlay);
					}
				}, timer * 1000);
			}
		}				
		$j(overlay).css({'z-index':1});
		if(css){
			Object.keys(css).forEach(function(key){
				$j(overlay).css(key,css[key]);
			});
		}
		if(attributes){
			Object.keys(attributes).forEach(function(key){
				if(key === 'hidden'){
					$j(overlay).hide();
				} else {
					$j(overlay).attr(key,css[key]);
				}
			});
		}
		return overlay;
	},
	showTooltip : function(message, options){
		if(!this.tooltip){
			this.tooltip = $j('#ws_tooltip')[0];
		}
		this.tooltip.show(message, options);
	},	
	/**
	 * Shows an alert message dialog.
	 * 
	 * @param {String} message A message to be shown in the alert dialog.
	 * @param {Integer} type An alert type possible values are $M.alerts.info or $M.alerts.warn or $M.alerts.error or $M.alerts.question
	 * @param {Object} contentProps An object that contains key value pairs that are used to set as the properties of the component that is created based on the content name passed.
	 * @return {Object} The alert dialog.
	 */
	alert: function(message, type, contentProps){
		message = HTMLEncoder.sanitize(message);
		this._blockWait = true;
		var typeTitle = $M.localize('uitext', 'mxapibase', 'SystemMessage');
		var content = this.$.alert.cloneNode(true);
		type = this.setupMessage(1, message, type, content);
		var count = 0;
		var id = '';
		do{
			id = 'Sys_'+type+count;
			count++;
		}
		while ($j('#'+id).length>0);
		var dialog = $M.showDialog(null, id, typeTitle, content, false,undefined, contentProps);
		var footer = dialog.$.footer;
		if(footer && footer.firstElementChild){
			$j(footer.firstElementChild).empty();
			var ok = Polymer.Base.create('maximo-button',{'default':'true','id':dialog.id+'alert_footer_ok','label':this.localize('uitext', 'mxapibase', 'Ok')});
//			ok.onTap = function(){
//				dialog.close();
//			};
			ok.addEventListener("tap", function(){
				dialog.close();
			});
			
			//ok.listen(ok, 'tap', 'onTap');
			//ok.bindEvent(ok, 'tap', );
			$j(dialog.$.footerRow).css({'display':''});
			$j(dialog.$.footerRow).show();
			//$j(dialog.$.dialog).css({'max-width':'500px'});
			$j(footer).css({'text-align':'center'});
			Polymer.dom(footer.firstElementChild).appendChild(ok);
		}
		window.setTimeout(function(){
			$j('#'+id+'_dialog').attr('role','alertdialog');
		},200);
		this._blockWait = false;
		$j(dialog.$.internal).css('overflow','hidden');
		if($M.isMobile()){
			$j(dialog.$.internal).css('max-height','400px');
			$j(dialog.$.dialog).find('tbody').css('display','inline-table');
		}
		return dialog;
	},
	
	/**
	 * Shows a confirmation dialog.
	 * 
	 * @param {String} message A message to be shown in the confirmation dialog.
	 * @param {Object} callback A function to be called when the confirmation dialog is closed based on user selected option
	 * @param {Object} caller An object representing the caller on which the callback function need to be called.
	 * @param {Integer|String} defaultButton 0/yes,1/no,2/cancel,3/ok can be passed to indicate which button should be set as the default button
	 * @param {Array} buttons An array of 0/yes,1/no,2/cancel,3/ok values representing the buttons to be shown in the confirmation dialog.
	 * @param {Object} additional An additional information to be passed to the callback function
	 * @param {Integer} type An alert type possible values are $M.alerts.info or $M.alerts.warn or $M.alerts.error or $M.alerts.question
	 * @param {Boolean} cancelCallback A boolean, true indicates that the callback should be applied to the cancel button
	 * @param {Object} contentProps An object that contains key value pairs that are used to set as the properties of the component that is created based on the content name passed.
	 * @return {Object} A confimation dialog.
	 */
	confirm: function(message, callback, caller, defaultButton, buttons, additional, type, cancelCallback, contentProps){ //defaultButton is an integer 0:yes, 1:no, 2:cancel, 3:ok
		var dialog = this.alert(message, type?type:$M.alerts.question, contentProps);
		this.systemDialog = dialog;
		var footer = dialog.$.footer;
		if(footer && footer.firstElementChild){
			switch(defaultButton){
				case 0:
				case 'yes':
					defaultButton = 'yes';
					break;
				case 1:
				case 'no':
					defaultButton = 'no';
					break;
				case 2:
				case 'cancel':
					defaultButton = 'cancel';
					break;
				case 3:
				case 'ok':
					defaultButton = 'ok';
					break;
				default:
					defaultButton = 'none';
					break;
			}
			if(callback){
				$j(footer.firstElementChild).empty();
				$j(footer).css({'text-align':$M.dir !== 'rtl'?'right':'left'});
				var yes = Polymer.Base.create('maximo-button',{'default':(defaultButton==='yes'),'id':dialog.id+'_confirm_footer_yes','label':this.localize('uitext', 'mxapibase', 'Yes')});
				yes.onTap = function(){
					dialog.close();
					this.async(function(){
						callback.apply(caller, [true,additional]);	
					}, 100);
				};
				yes.listen(yes, 'tap', 'onTap');
				if(defaultButton==='yes'){
					dialog.focusElement = yes.$.button;
				}
				Polymer.dom(footer.firstElementChild).appendChild(yes);
				var no = Polymer.Base.create('maximo-button',{'default':(defaultButton==='no'),'id':dialog.id+'_confirm_footer_no','label':this.localize('uitext', 'mxapibase', 'No')});
				no.onTap = function(){
					dialog.close();
					this.async(function(){
						callback.apply(caller, [false, additional]);
					}, 100);
				};
				no.listen(no, 'tap', 'onTap');
				if(defaultButton==='no'){
					dialog.focusElement = no.$.button;
				}
				Polymer.dom(footer.firstElementChild).appendChild(no);
				var cancel = Polymer.Base.create('maximo-button',{'default':(defaultButton==='cancel'),'id':dialog.id+'_confirm_footer_cancel','label':this.localize('uitext', 'mxapibase', 'Cancel')});
				cancel.onTap = function(){ 
					dialog.cancel(); 
					if (cancelCallback === true){
						this.async(function(){
							callback.apply(caller, [undefined, additional]);
						}, 100);
					}
				};
				cancel.listen(cancel, 'tap', 'onTap');
				Polymer.dom(footer.firstElementChild).appendChild(cancel);
				if(defaultButton==='cancel'){
					dialog.focusElement = cancel.$.button;
				}
				var ok = Polymer.Base.create('maximo-button',{'default':(defaultButton==='ok'),'id':dialog.id+'_confirm_footer_ok','label':this.localize('uitext', 'mxapibase', 'Ok')});
				ok.onTap = function(){ 
					dialog.close(); 
					this.async(function(){
						callback.apply(caller, [false, additional]);
					}, 100);
				};
				ok.listen(ok, 'tap', 'onTap');
				Polymer.dom(footer.firstElementChild).appendChild(ok);
				if(defaultButton==='ok'){
					dialog.focusElement = ok.$.button;
				}
				$j(footer.firstElementChild).find('button').each(function(){
					this.id = this.parentNode.id + '_' + this.id;
				});
				if(buttons){
					$j(yes.firstElementChild).css({'display':buttons.includes('yes')||buttons.includes(0)?'initial':'none'});
					$j(no.firstElementChild).css({'display':buttons.includes('no')||buttons.includes(1)?'initial':'none'});
					$j(cancel.firstElementChild).css({'display':buttons.includes('cancel')||buttons.includes(2)?'initial':'none'});
					$j(ok.firstElementChild).css({'display':buttons.includes('ok')||buttons.includes(3)?'initial':'none'});
				}
			}
		}
		return dialog;
	},
	/**
	 * Shows a confirmation dialog to handle MaxMessages that can have button options of Close, Ok, Cancel, Yes, No
	 * 
	 * @param {String} message A message to be shown in the confirmation dialog.
	 * @param {Object} callback A function to be called when the confirmation dialog is closed based on user selected option
	 * @param {Object} caller An object representing the caller on which the callback function need to be called.
	 * @param {Integer|String} defaultButton name can be passed to indicate which button should be set as the default button
	 * @param {Object} options An object representing the buttons to be shown and the values to be returned eg. {'yes': 8, 'no': 16, 'cancel': 4}
	 * @param {Object} additional An additional information to be passed to the callback function
	 * @param {Integer} type An alert type possible values are $M.alerts.info or $M.alerts.warn or $M.alerts.error or $M.alerts.question
	 * @return {Object} A confimation dialog.
	 */
	confirmMaxMessage: function(message, callback, caller, defaultButton, options, additional, type){
		var dialog = this.alert(message, type?type:$M.alerts.question);
		this.systemDialog = dialog;
		var footer = dialog.$.footer;
		if(footer && footer.firstElementChild){
			if(callback){
				$j(footer.firstElementChild).empty();
				$j(footer).css({'text-align':$M.dir !== 'rtl'?'right':'left'});
				var keys = Object.keys(options);
				for (var i=0; i<keys.length; i++){
					var textId = this.capitalize(keys[i]);	// buttons are yes,no,cancel but text Ids are Yes, No, Cancel etc.
					var btnVal = options[keys[i]];
					var btn = Polymer.Base.create('maximo-button',{'default':defaultButton,
						'id':dialog.id+'_confirm_footer_btn_'+textId,'value':btnVal,
						'label':this.localize('uitext', 'mxapibase', textId)});
					btn.onTap = function(e){
						var btn = e.currentTarget;
						var value = parseInt(btn.value);
						if (value === 1 || value === 4){
							dialog.cancel();	// call cancel for close/cancel!
						} else {
							dialog.close();
						}
						
						this.async(function(){
							callback.apply(caller, [value, additional, caller]);	
						}, 100);
					};
					btn.listen(btn, 'tap', 'onTap');
					if(defaultButton){
						dialog.focusElement = btn.$.button;
					}
					Polymer.dom(dialog.$.footer.firstElementChild).appendChild(btn);
					$j(btn.firstElementChild).attr({'display':'initial'});
				}
			}
		}
		return dialog;
	},
	/**
	 * capitalize first character of a string  (yes becomes Yes)
	 */
	capitalize: function(text){
		if (text && text.length > 0){
			text = text[0].toUpperCase() + (text.length > 1 ? text.slice(1): '');
		}
		return text;
	},
	
	showFlyout : function(contextOrId, content, owner, contentprops){
		return this._showDialog(null, contextOrId, null, content, null, owner, contentprops, true);
	},
	
	showDialog : function(parent, contextOrId, title, content, fullSize, owner, contentprops){
		return this._showDialog(parent, contextOrId, title, content, fullSize, owner, contentprops, false);
	},
	
	/**
	 * Creates a component based on the content name that is passed and shows that in a dialog.
	 * In a mobile phone view, the dialog takes up the entire screen.
	 * 
	 * @param {Object} parent A parent object
	 * @param {Object|String} contextOrId An object that has id as an attribute or a string representing id for the dialog
	 * @param {String} title A title to be used for the dialog
	 * @param {Object|String} content A component to be used to fill inside the dialog or a string representing the maximo component 
	 *      name that will be created and shown inside the dialog
	 * @param {Boolean} fillSize A flag to indicate whether the dialog should take up the entire space or not.
	 * @param {Object} owner A owner object    
	 * @param {Object} contentprops An object that contains key value pairs that are used to set as the properties of the component 
	 *      that is created based on the content name passed.
     * @return {Object} Returns the dialog object.
	 */
	_showDialog : function(parent, contextOrId, title, content, fullSize, owner, contentprops, flyout){
		this.toggleWait(true);
		var my = this;
		var id,context;
		if(typeof contextOrId === 'object'){
			id = contextOrId.id+'_dialog';
			context = contextOrId;
		}
		else {
			id = contextOrId;
		}
		if(my.dialogs.map[id]){
			console.warn('Already showing dialog with the id: '+id +'!');
			my.flashElement($j('#'+id));
			return;
		}
		my.toggleBlur(true);
		my.toggleScroll(false);
		if(!title){
			title = '';
		}
		var props = {'id': id,'title':title, 'fullSize': fullSize, 'owner' : owner};
		if(contentprops){
	        var keys = Object.keys(contentprops);
	        var i = 0;
	        while (i < keys.length){
	          props[keys[i]] = contentprops[keys[i]];
	          i += 1;
	        }
		}
		if(context){
			if(context._rowstamp){
				props.record = context;
			}
			else {
				props.recordData = context;
			}
		}
		if(typeof content === 'object'){
			props.contentObject = content;
		}
		else if(content.indexOf('maximo-') === 0){
			props.contentObject = Polymer.Base.create(content);
				//document.createElement(content);
			props.contentObject.id = id+'_content';
			props.contentObject.recordData = props.recordData;
			props.contentObject.recordIndex = props.recordIndex;
			props.contentObject.record = props.record;
			props.contentObject.parent = parent;
			props.contentObject.dynamic = true;
	        //Iterate thru all content props and assign them to the content if necessary.
	        if(contentprops){
	          var propKeys = Object.keys(contentprops);
	          var keyIndex = 0;
	          while (keyIndex < propKeys.length){
	            props.contentObject[propKeys[keyIndex]] = contentprops[propKeys[keyIndex]];
	            keyIndex += 1;
	          }
	        }
			if(!props.title){
				props.title = props.contentObject.label?props.contentObject.label:'';
			}
		}
		else { 
			var contentElement = document.getElementById(content);
			if(contentElement && typeof contentElement === 'object'){
				props.contentObject = document.getElementById(content);
				if($j(props.contentObject).attr('hidden')){
					$j(props.contentObject).css({'display':'inherit'});
					$j(props.contentObject).attr({'hidden':false});
					$j(props.contentObject).attr({'data-hideme':'true'});
				}
			}
			else { //must be string content
				props.content = content;
			}
		}
		if(props.contentObject){
			props.contentObject.parent = parent;
		}
		var type = 'maximo-dialog';
		if(flyout){
			type = 'maximo-flyout';
		}
		var element = Polymer.Base.create(type, props);
		if (!parent || (contentprops && contentprops.placeInBody)) {
			var self = this;
			this.async(function(){
				if(self.workScape && self.workScape.$.content) {
					$j(self.workScape.$.content).append(element);
				}
				else {
					$j('body').append(element);
				}
			}, 100);
			
		}
		else {
			$j(parent).append(element);
		}
		
		if (contentprops && contentprops.createdevent) {
			parent.fire(contentprops.createdevent, element);
		}
		if(flyout && element.owner){
			element.fire = function(name, params){
				element.owner.fire(name, params);
			};
		}
		return element;
	},
	returnToLogin: function(messageKey, apiKey){
	   $M.clearGuestUser();
		var message = HTMLEncoder.sanitize(localStorage.getItem('loginMessage'));
    	sessionStorage.clear();
    	if(message && !messageKey){
    		messageKey = message;
    	}
    	var logoutLocation = 'index';
    	if(apiKey){
    		logoutLocation= 'guest?apiKey='+apiKey;
    	} 
     
    	if(this.appserversecurity){
    		if(messageKey !== 'blueid' ){
				logoutLocation = 'logout.html';
				if(typeof messageKey !== 'undefined'){
					logoutLocation += '?messageKey='+messageKey;
					if(apiKey){
			    		logoutLocation += '&apiKey='+apiKey;
			    	}
				}else{
				  	if(apiKey){
			    		logoutLocation += '?apiKey='+apiKey;
			    	}
				  
				}
				
    		}	
    	}
    	else {
    		localStorage.setItem('loginMessage',HTMLEncoder.sanitize(messageKey));
    	}
    	this.appserversecurity = null;
    	document.location = logoutLocation;
    },
    
    /*
     * Show a notification with a custom timeout
     */
    notifyWithCustomTimeout: function(message, type, timeout){
    	var originalTimeout = $M.notificationtimeout
		if(timeout && typeof timeout === 'number'){
			this.notificationtimeout = timeout;
		}
    	this.notify(message, type);
    	this.async(function(){
			$M.notificationtimeout = originalTimeout;	
		}, 50); 
    },
    
	/**
	 * Shows a notification message.
	 * 
	 * @param {String} message A message to be shown in the alert dialog.
	 * @param {Integer} type An alert type possible values are $M.alerts.info or $M.alerts.warn or $M.alerts.error or $M.alerts.question
	 */
    notify : function(message, type, completeCallback, undoCallback, persist){
		message = HTMLEncoder.sanitize(message);
    	var undoNotification = (completeCallback !== undefined &&  completeCallback !== null || undoCallback !== undefined && undoCallback !== null);
    	var completeTimer;
    	
    	if(!type){
    		type = $M.alerts.info;
    	}
    	if(type === $M.alerts.error || message.length > 200){
			$M.alert(message, type);
			return;
    	}
		var count = 0;
		var id = '';
		do{
			id = 'Notify_'+count;
			count++;
		}
		while ($j('#'+id).length>0);
		
		//On small screen, When a toast goes beyond text limit, convert to pop-up dialog
		if(this.screenInfo.size === 'small' && message.length > 50){
			var smallScreenData = {};
	    	smallScreenData.message = message;
	     	smallScreenData.id = id;
	      	smallScreenData.fullSize = true;
	      	smallScreenData.undoNotification = undoNotification;
	      	smallScreenData.type = type; 
	      	smallScreenData.completeCallback = completeCallback; 
	      	smallScreenData.undoCallback = undoCallback;
	      	this.smallDeviceNotificationDialog(smallScreenData);
	      	return;
		}
			
		var notification = Polymer.Base.create('maximo-notification', {'id':id});
		var content;
		
		var my = this;
		content = notification.$.notification;

		if (undoNotification){
			// set completeCallback timer
			if (completeCallback){
				// do timer
				completeTimer = window.setTimeout(function() {
					if (completeCallback) {
						completeCallback();
					}
				}, this.undoNotificationtimeout * 1000);

			}
			// set undo button
			var undoButton = notification.$.undoNotificationButton;
			undoButton.hidden = false;
			undoButton.addEventListener('tap', function(e) {
				if (completeTimer) {
					window.clearTimeout(completeTimer);
				}
				if (undoCallback) {
					undoCallback();
				}
				my.removeNotification(content);
			});
		}
		
		// On small screen, convert a toast into dialog when it goes beyond text limit
		$j(content).attr({'id':id});
		type = this.setupMessage(0, message, type, content);
		this.notifications.map[id] = $j(content);
		this.notifications.stack.push(id);
		
		var props = {};
		props.transform = 'scale(0)';
		$j(content).css(props);
		$j(content).attr({'hidden':false});
		$j(content).toggleClass('notification'+type, true);
		$j(this.$.notificationContainer).append(notification);
		
		this.async(function(){
			$j(content).css({'transform':'scale(1)'});
			var timeoutTime = $M.notificationtimeout;
			if (undoNotification){
				timeoutTime = this.undoNotificationtimeout;
			}
			if(persist){
				timeoutTime = 0;
			}
			if(timeoutTime !== 0){
				this.async(function(){
					my.removeNotification(notification);
				}, timeoutTime*1000);
			}
			else {
				$j(notification).find('iron-icon.closeIcon').removeAttr('hidden');
			}
		}, 10);
		if(navigator.vibrate){
			navigator.vibrate(500);
		}
    },
    removeNotification : function(notificationToRemove) {
		if(!notificationToRemove){
			return;
		}
		var my = this;
		$j(notificationToRemove).css({'height':'0px', 'opacity':'0', 'border-bottom':'0px','padding-top':'0px'});
		this.async(function(){
			$j(notificationToRemove).remove();
			$M.arrayRemove(my.notifications.stack, notificationToRemove.id);
			delete my.notifications.map[notificationToRemove.id];
		}, 300);

    },
    
    
	setupMessage : function(type, message, level, element){
		//type: 1 - alert, 0 - toast
		var icon, className;
		switch(level){
			case $M.alerts.info:
				
				if(type===1){
					className = 'svgAlertBlue';
					icon = 'info';
				}
				else {
					className = 'svgAlertGreen';
					icon = 'maximo-based:complete';
				}
				level= 'info';
				break;
			case $M.alerts.warn:
				className = 'svgAlertOrange';
				icon = 'maximo-based:warn';
				level= 'warn';
				break;
			case $M.alerts.error:
				className = 'svgAlertRed';
				icon = 'error';
				level= 'error';
				break;
			case $M.alerts.question:
				className = 'svgAlertYellow';
				icon = 'help';
				level= 'question';
				break;
			case $M.alerts.warninfo:
				className = 'svgAlertYellow';
				icon = '';
				level= 'warninfo';
				break;
			default:
				className = '';
				icon = '';
				level= '';
				break;
		}
		var internal = $j(element);
		switch(type){
			case 0:
				internal.find('.notificationCell').html(HTMLEncoder.sanitize(message));
				internal.find('.notificationCell').attr({'title':HTMLEncoder.sanitize(message)});
				internal.find('.messageIcon').toggleClass('notification'+level, true);
				break;
			case 1:
				internal.find('.alertMessageCell').html(HTMLEncoder.sanitize(message));
				break;	
		}
		
		internal.attr({'hidden':false});
		var iconElement = internal.find('iron-icon.messageIcon');
		if(icon!==''){
			iconElement.attr({'icon':icon});
			iconElement.toggleClass(className, true);
			iconElement.attr('class', iconElement.attr('class')+' maximo-dialog');
		}
		else {
			iconElement.hide();
			internal.find('.alertMessageCell').css({'padding':'0px'});
		}
		return level;
	},
	
	/*
	 * Close all dialogs with a promise and a 300ms delay
	 */
	closeAllDialogs: function(){
		var context = this;
		return new Promise(function (resolve, reject) {
			var count = this.dialogCount();
			for(var index=0; index < count; index++){
				this.closeDialog();
			}
			context.async(function(){
				resolve();				
			}, 300);
		}.bind(this));
	},
	
	/**
	 * Closes the currently active dialog.
	 */
	closeDialog: function(){
		var dialogCount = this.dialogCount();
		var currentDialog = $j('#'+this.dialogs.stack[dialogCount-1]);
		if(currentDialog && currentDialog[0]){
			currentDialog[0].close();
		}
	},
	
	/**
	 * Toggles the blur state on/off.
	 * @param {Boolean} state Pass true to turn the blur on, otherwise pass false.
	 */
	toggleBlur: function(state){
		if(typeof state !== 'boolean'){
			state = true;
		}
		var target = $j('.maximo-workscape.wrapper');
		if(target.length===0){
			target = $j('.loginpanel');
		}
		var dialogCount = this.dialogCount();
		if(dialogCount>0){
			target = $j('#'+this.dialogs.stack[dialogCount-1]).find('.dialog');
		}
		
		target.toggleClass('song2',state);		
		if(!$M.isMobile()){
			this._fixFooterPosition(state);
		}
		
		return target;
	},
	
	toggleScroll : function(scroll){
		this.scroll = scroll;
		this.bodyScroll = $j('body').scrollTop();
	},
	
	/**
	 * Returns the number of dialogs that are currently open.
     * @return {Integer} Returns the number of dialogs currently open.
   	 */
	dialogCount: function(){
		return this.dialogs.stack.length;
	},
	flashElement: function(element, strength){
		$M.highlightElement(element, strength);
		window.setTimeout(function(){
			$M.highlightElement(element, strength);
		}, 500);
	},
	highlightElement: function(element, strength){
		if(!strength){
			strength = 1.05;
		}
		var transition = element.css('transition');
		element.css({'transition':'all .3s'});
		element.css({'transform':'scale('+strength+')'});
		window.setTimeout(function(){
			element.css({'transform':'scale(1)'});
			if(transition){
				window.setTimeout(function(){
					element.css({'transition':transition});
				}, 500);
			}
		}, 300);
	},
	toggleWait: function(state){
		if(!this.wait || this._blockWait){
			return;
		}
		if(typeof state !== 'boolean'){
			state = true;
		}
		var zIndexTarget = this.toggleBlur(state);
		var zIndex = parseInt(zIndexTarget.css('z-index'));
		if(isNaN(zIndex)){
			zIndex = 1;
		}
		zIndex = zIndex+1;
		this.wait.zIndex = zIndex;
		if(this.wait){
			if(state || !this.lockWait){
				$j(this.wait.$.wait).css({'zIndex':'10000','position':'fixed'});
				this.wait.toggle(state);
			}
		}
		if(state){
			$j('body').addClass('overflow-y');
		}else{
			$j('body').removeClass('overflow-y');
		}
	},
	/**
	 *	Generates a Maximo link that points to a specific record in an application.
	 */
	_getMaximoRecordLink: function(appName,uniqueId,additionalEvent,additionalEventValue){
		var maximoclassiclink = this.getMaxauth().maximoclassiclink;
		if (!maximoclassiclink){
			maximoclassiclink =  this.getMaxauth().baseUri;
		}
		var maximoLocation =maximoclassiclink+'/ui/?event=loadapp&value='+appName.toLowerCase();
		if(uniqueId){
			maximoLocation +='&uniqueid='+uniqueId;	
		}
		if(additionalEvent){
			maximoLocation +='&additionalevent='+additionalEvent;
		}
		if(additionalEventValue){
			maximoLocation +='&additionaleventvalue='+additionalEventValue;
		}
		maximoLocation+='&forcereload=true';
		return maximoLocation;
	},
	/**
	 * Does current user have access to a base application.
	 */
	hasAccessToBaseApp: function(appName){
		try {
			return this.getMaxauth().whoami.applications[appName.toUpperCase()] !== undefined;
		}
		catch(error){
			return false;
		}
	},

	/**
	 *	Opens Maximo and brings up the selected record in a new tab.
	 */
	openMaximoRecordInNewTab: function(appName,uniqueId,additionalEvent,additionalEventValue) {
		if($M.login.$.authenticator.isAuthenticationNeeded()){
			$M.workScape.returnToLogin();
		}
		if(this.hasAccessToBaseApp(appName)){
			var link = this._getMaximoRecordLink(appName,uniqueId,additionalEvent,additionalEventValue);
			window.open(link,'maximo','noopener');
		}
		else {
			this.alert($M.localize('uitext','mxapibase','no_access'));
		}
	},

	/**
	 *	Opens Maximo and brings up the selected record in an iframe.
	 */
	openMaximoRecord: function(appName,uniqueId,additionalEvent,additionalEventValue) {
		if($M.login.$.authenticator.isAuthenticationNeeded()){
			$M.workScape.returnToLogin();
		}
		if(this.hasAccessToBaseApp(appName)){
			var link = this._getMaximoRecordLink(appName,uniqueId,additionalEvent,additionalEventValue);
			$M.workScape.openTpaeApplication(link, uniqueId);
		}
		else {
			this.alert($M.localize('uitext','mxapibase','no_access'));
		}
	},

	/**
	 * Does current user have access to a graphite application.
	 */
	 hasAccessToNextGenApp: function(appName){
		try {
			return this.getMaxauth().whoami.workcenters[appName.toLowerCase()] !== undefined;
		}
		catch(error){
			return false;
		}
	},

	/** 
	 *	Open Graphite in a new tab.
	 */
	 openNextGenApp: function(appName, uniqueId) {

		if($M.login.$.authenticator.isAuthenticationNeeded()){
			$M.workScape.returnToLogin();
		}
		if(this.hasAccessToNextGenApp(appName)){

			var maximoclassiclink = this.getMaxauth().maximoclassiclink;
			if (!maximoclassiclink){
				maximoclassiclink =  this.getMaxauth().baseUri;
			}
			maximoclassiclink +=  this.getMaxauth().apiContext;

			var maximoLocation =maximoclassiclink+'/graphite/'+appName.toLowerCase();

			if (uniqueId) {
				maximoLocation +=`?_graphite-ctx=appdetails&appdetails={"uid":${uniqueId}}`; 
			}

			window.open(maximoLocation,'maximo','noopener');
		}
		else {
			this.alert($M.localize('uitext','mxapibase','no_access'));
		}
	},
	
	checkLicenses: function(licenses){
		// Options are ORed; if any is true the user has access
		var checkLicenses = licenses.split(',');
		for (var j=0; j<checkLicenses.length; j++){
			if (this.licenseGranted(checkLicenses[j]) === true) {
				return true;
			}
		}
		return false;
	},
	licenseGranted: function(license){
		var licenses = this.getLicenses();
		if (licenses === undefined){  //Should not have gotten this far
			console.log('licenses is undefined');
			return false;
		}
		if (licenses.INTERNALONLY){
			//console.log('license authorized for ' + license + ' due to INTERNALONLY');
			return true;
		}
		if (licenses[license]){
			//console.log('license authorized for ' + license);
			return true;
		
		}
		console.log('license denied for ' + license);
		return false;
	},
	checkSigoptions: function(sigoptions){
		// Options are ORed; if any is true the user has access
		var checkOptions = sigoptions.split(',');
		for (var j=0; j<checkOptions.length; j++){
			if (this.sigoptionGranted(checkOptions[j]) === true) {
				return true;
			}
		}
		return false;
	},
	sigoptionGranted: function(sigoption){
		var options = this.getSigoptions();
		if (options === undefined || options === null){  //Should not have gotten this far
			console.log('options is undefined');
			return false;
		}

		var inverse = false;
		// apply inverse logic if sigtoption begins with !
		if(sigoption.startsWith('!')){
			inverse = true;
			sigoption = sigoption.substring(1);
		}
		// Option may be in the format WORKCENTEROPTION or OSNAME:OSOPTION
		var segments = sigoption.split(':'),
		firstPart = segments[0],
		secondPart = segments[1];

		if(options[firstPart] === undefined || (secondPart && options[firstPart][secondPart] === undefined)){
			if(inverse){
				if(this.debug){
					console.log('access allowed on ' + sigoption);	
				}
				return true;	
			}
			if(this.debug){
				console.log('access denied on ' + sigoption);
			}
			return false;
		}
		
		if((options[firstPart] && !secondPart) || (secondPart && options[firstPart][secondPart])){
			if(inverse){
				if(this.debug){
					console.log('access denied on ' + sigoption);
				}
				return false;
			}
			if(this.debug){
				console.log('access allowed on ' + sigoption);
			}
			return true;
		}
		return inverse?true:false;
	},
	
	/**
	 * Returns a localized message based on the information provided.
	 * 
	 * @param {String} type Either uitext or messages depending on wherther the message 
	 *      to be localized is for labels or for messages to be shown to the user.
	 * @param {String} group An Object Structure Name for Labels or a Message Group name for Messages
	 * @param {String} key A label or message key.
	 * @param {Array} params List of parameters that can be substituted in the message.
	 */
	localize: function(type, group, key, params){ // need to change to this once files are updated
		var message = key;
		/* stub for resolving labels */
		var strings = $M.demo?this.resources.demo_strings:this.resources.strings;
		if(strings){
		var bundle = strings[type];
		if(bundle){
			var bundleGroup = bundle[group];
			if(bundleGroup !== undefined){
				var bundleMessage = bundleGroup[key];
				if(bundleMessage !== undefined){
					message = bundleMessage;
				}
			}
		}
		if(params){
			message = this.replaceParams(message, params);
		}
		if (message !== undefined){
			message = message.replace(/\&quot;/g, '\'').replace(/\&nbsp;/g, ' ');
		}
		//Helps in testing UI strings with mocked values.
		//Data from server is not mocked unless a full mocked language is installed.
		switch (this.mock){ 
			case 'ja':
				message = '[(\')一構ソチ‐ '+message+']';
				break;
			case 'de':
				message = '[(\')~~~~~~~~~~ '+message+']';
		}
		}
		return message;
	},
	replaceParams: function(message, params){
		if(message && params){
			params.forEach(function(param,index){
				message = message.replace('{'+index+'}',param);
			});
		}
		return message;
	},
	cloneRecord: function(record){
		return $j.extend(true, {}, record);
	},

	/*
	* Add a listener to notify when an event fires 
	*/
	subscribe: function(event,listener){
		if(!this._eventSubscribers[event]){
			this._eventSubscribers[event] = [];
		}
		if(!this._eventSubscribers[event].includes(listener)){
			this._eventSubscribers[event].push(listener);
		}
	},
	
	/*
	 * Remove notification listener
	 */
	unsubscribe: function(event, listener){
		var subscribers = this._eventSubscribers[event];
		if(subscribers && subscribers.length > 0){
			var removeIndex = -1;
			subscribers.forEach(function(subscriber, index){
				if(listener === subscriber){
					removeIndex = index; 
				}
			});
			if(removeIndex > -1){
				this._eventSubscribers[event].splice(removeIndex, 1);
			}
		}
	},
	
	/*
	 * publish event to all matching subscribers
	 */
	publishEvent: function(eventName, detail){
		var subscribers = this._eventSubscribers[eventName];
		if(subscribers){
			subscribers.forEach(function(listener){
				listener.dispatchEvent(new CustomEvent(eventName, {
					detail: detail,
					bubbles: false,
					cancelable: true
				}));
			});
		}			
	},
	
	_getErrorResponse: function (error) {
		if (error) {
			if (error.request) {
				if (error.request.xhr) {
					if (error.request.xhr.response) {
						if (error.request.xhr.response.Error) {
							return error.request.xhr.response.Error;
						}
					}
				}
			}
		}
		return null;
	},
	showResponseError: function (error) {
		var e = this._getErrorResponse(error);
		if (e) {
			var type ='';
			var t = e.reasonCode ? e.reasonCode[e.reasonCode.length - 1] : '';
			switch(t) {
				case 'I':
					type = this.alerts.info;
					break;
				case 'W':
					type = this.alerts.warn;
					break;
				case 'E':
					type = this.alerts.error;
					break;
				default:
					type = this.alerts.info;
					break;
			}

			this.alert(e.message, type);
		}
	},
	getPixelsPerInch: function() {
		if(!this.screenInfo.ppi){ //this will not change
			var div = document.createElement('div');
			div.id = 'div_screensize';
			div.innerHTML = '.';
			document.body.appendChild(div);
			$j(div).css({'width':'1in'});
			this.screenInfo.ppi = parseFloat($j(div).width());
			$j(div).remove();
		}
		return this.screenInfo.ppi;
	},
	getOrientation : function() {
		this.getPhysicalSize();
		if (window.screen && window.screen.orientation && window.screen.orientation.type) {
			if (window.screen.orientation.type.indexOf('landscape') !== -1) {
				this.screenInfo.orientation = 'landscape';
			}
			else {
				this.screenInfo.orientation = 'portrait';
			}
		}
		else {
			this.screenInfo.orientation = parseInt(this.deviceSize.width)<parseInt(this.deviceSize.height)?'portrait':'landscape';			
		}
		$j('body').attr({
	    	'data-orientation' : this.screenInfo.orientation
	    });
		
		return this.screenInfo.orientation;
	},
	getPhysicalSize: function(){
		if(!this.physicalSizeHandler){
			this.physicalSizeHandler = $j(window).on('resize', function(){
				if($M.resizeTimer){
					window.clearTimeout($M.resizeTimer);
				}
				$M.resizeTimer = setTimeout(function(){
					$M.getOrientation();
					if($M.workScape){
						$M.workScape.fire('maximo-screen-resize');
					}
				}, 250);
			});
		}
		var ppi = this.getPixelsPerInch();
		this.screenInfo.ppi = ppi;
		this.screenInfo.width = ($j(window).width() / ppi).toFixed(2);
		this.screenInfo.height = ($j(window).height() / ppi).toFixed(2);
		this.screenInfo.size = this.screenInfo.width<this.carouselMax||this.screenInfo.height<this.carouselMax?'small':'large';
		this.deviceSize = {
			'width' : this.screenInfo.width,
		    'height' : this.screenInfo.height
		};
		$j('body').attr({
			'data-ppi' : this.screenInfo.ppi,
	    	'data-width' : this.screenInfo.width,
	    	'data-height' : this.screenInfo.height,
	    	'data-size' : this.screenInfo.size
	    });
		
		this.getUserDevice();
		$j('#maximo_tourController_tourCanvas').css('height', $j(window).height());
		if($M.isMobile()){
			var tour = $M.querySelector('#tourController');
			if(tour && tour._currentStep){
				tour.hasTourRun = false;
			}
		}
		return this.deviceSize;
	},
	getUserDevice : function(){
		var ua,device;
		ua = navigator.userAgent;
		$M.browser_product = navigator.product;
		$M.browser_vendor = navigator.vendor;
		if(ua.indexOf('iPhone') !== -1){
			device = 'phone';
		}
		else if(ua.indexOf('iPad') !== -1){
			device = 'tablet';
		}
		else if(ua.indexOf('Android') !== -1){
			if(this.screenInfo.size === 'small'){
				device = 'phone';
			}
			else{
				if(this.screenInfo.orientation === 'landscape'){
					if(this.screenInfo.width < (this.carouselMax*2)){
						device = 'phone';
					}
					else{
						device = 'tablet';
					}
				}
				else{
					device = 'tablet';
				}
			}
		}
		else{
			device = 'desktop';
		}
		this.screenInfo.device = device;
	},
	uniqueAttributeSource : '_id',
	uniqueAttributeTarget : 'id',
	templates : {},
	templateUpdated: function(object){
		// method to indicate a template has been refreshed
		if (object){
			var templateId = object.id;
			if (templateId){
				this.templates[templateId] = object;
				// do any automation code here (i.e. fix)
				this._updateTemplateInstanceIds(object);
			}
		}
	},
	
/*
	_updateListInstanceIds: function(list, component){ //coming in with DIV containing repeated elements
		if (list){
			var collection = list._collection;
			if(collection){
				var instances = $j(list.$.items).children('div');
				for(var i=0; i<instances.length; i++){
					var instance = list.modelForElement(instances[i]);
					if(!instance || (typeof instance.index === 'undefined')){
						continue;
					}
					// use a uniqueAttribute from the template(or collection) that specifies what
					// the attribute will be it will default to href
					var idSuffix = '';
					if(this.uniqueAttributeSource === '_id'){
						var record = collection.userArray[instance.index];
						if(record){
							var uniqueKey = record[this.uniqueAttributeSource];
							if (uniqueKey){
								uniqueKey = this.makeSafeId(uniqueKey);
								idSuffix = uniqueKey.substring(uniqueKey.lastIndexOf('/')+1, uniqueKey.length);
							}
						}
					}
					else {
						// it's a comma separated list of attributes
						var attrs = this.uniqueAttributeSource.split(',');
						var sep = '';
						for (var j=0; j<attrs.length; j++){
							idSuffix = idSuffix + sep + collection.userArray[instance.index][attrs[j]];
							sep = '_';
						}
					}
					instance._children.forEach(function(child){
						if (child.nodeType === 1){	// element
							this._addIdSuffix(child, idSuffix, true);
						}
					}, this);
				}
			}
		}
	},
*/
	
	/** 
	 * Walks template elements and applies a key from the record across child IDs
	 */
	_updateTemplateInstanceIds: function(template){
		if (template && template._instances && template._instances.length){
			for(var i=0; i<template._instances.length; i++){
				var instance = template._instances[i];
				// use a uniqueAttribute from the template(or collection) that specifies what
				// the attribute will be it will default to href
				var idSuffix = this._buildUniqueId(instance.dataHost.collection.userArray[i], this.uniqueAttributeSource);
				if(idSuffix){
					instance._children.forEach(function(child){
						if (child.nodeType === 1){	// element
							this._addIdSuffix(child, idSuffix,true);
						}
					}, this);
				}
			}
		}
	},
	
	/*
	 * Build unique id from record
	 */
	_buildUniqueId: function(record, uniqueAttributeSource){
		var idSuffix;
		if (record){
			if(this.uniqueAttributeSource === '_id'){
				var uniqueKey = record[uniqueAttributeSource];
				if (uniqueKey){
					uniqueKey = this.makeSafeId(uniqueKey);
					idSuffix = uniqueKey.substring(uniqueKey.lastIndexOf('/')+1, uniqueKey.length);
				}
			}
			else {
				// it's a comma separated list of attributes
				var attrs = uniqueAttributeSource.split(',');
				var sep = '';
				for (var j=0; j<attrs.length; j++){
					idSuffix = idSuffix + sep + record[attrs[j]];
					sep = '_';
				}
			}
		}
		return idSuffix;
	},
	
	/*
	 * Create an element with passed properties
	 */
	createElement: function(type, props){
		var element = document.createElement(type);
		if(props){
			var context = this;
			Object.keys(props).forEach(function(key){
				context.setRelatedData(element, key, props[key]);
			});
		}
		return element;
	},

	/*
	 * Set unique ids on all internal elements of an updated list element 
	 */
	_updateListItemChildIds: function(list, item){
		var idSuffix, record;
		if(item && list._collection && list.modelForElement(item)){
			record = list._collection.userArray[list.modelForElement(item).index];
			idSuffix = this._buildUniqueId(record, this.uniqueAttributeSource);
			if(idSuffix){
				var context = this;
				$j(item).children().each(function(){
					var child = this;
					if (child.nodeType === 1){	// element
						context._addIdSuffix(child, idSuffix,true);
					}
				}, this);
			}
		}
	},
	
	_addIdSuffix: function(element, suffix, reset, pre){
		if(typeof reset === undefined){
			reset = false;
		}
		var matched = false;
		if(reset || !element.hasAttribute('data-uniqueid')){
			if(element.hasAttribute('id') && element.tagName !== 'TEMPLATE'){
				if(element.getAttribute('id').includes(suffix)){
					matched = true;
				}
				if(!matched){
					if(!element.hasAttribute('original-id')){
						element.setAttribute('original-id', element.getAttribute('id'));
					}
					
					if(reset || !element.hasAttribute('data-identifier')){
						element.setAttribute('data-identifier', suffix);
					}
				
					if($j(element).hasClass('cardborder')){
						if(element.hasAttribute('data-index') && element.getAttribute('data-index')==='0'){
							element.setAttribute('tabIndex', '0');
						}
						$j(element).toggleClass('rtl',this.dir==='rtl');
						$j(element).on('keydown', function(e){
							switch(e.keyCode){
								case $M.keyCode.ENTER:
								case $M.keyCode.SPACEBAR:
									$j(e.currentTarget).trigger('click');
									break;
								case $M.keyCode.LEFT:
									if($j(e.currentTarget).prev().hasClass('cardborder')){
										e.currentTarget.removeAttribute('tabIndex');
										$j(e.currentTarget).prev().attr('tabIndex', '0');
										$j(e.currentTarget).prev().focus();
									}
									break;
								case $M.keyCode.UP:
									break;
								case $M.keyCode.RIGHT: //right
									if($j(e.currentTarget).next().hasClass('cardborder')){
										e.currentTarget.removeAttribute('tabIndex');
										$j(e.currentTarget).next().attr('tabIndex', '0');
										$j(e.currentTarget).next().focus();
									}
									break;
								case $M.keyCode.DOWN:
									break;
							}
						});
	
					}
					if(pre){
						element.setAttribute(this.uniqueAttributeTarget, suffix + element.getAttribute('original-id'));	
					}
					else {
						var extension = element.getAttribute('id-extension');
						if(!extension){
							extension = '';
						}
						var pathId = element.getAttribute('path-id');
						if(!pathId){
							pathId = '';
						}
						element.setAttribute(this.uniqueAttributeTarget, pathId + element.getAttribute('original-id') + suffix + extension);
						if($M.debug){
							console.log('Changing '+element[this.uniqueAttributeTarget]+' to [' + element.getAttribute('original-id') + suffix +']');
						}
					}
					element.setAttribute('data-uniqueid', true);
				}
			}
			// now do it's children
			if( !matched && element.children){
				for (var i=0; i<element.children.length; i++){
					var child = element.children[i];
					if (child.nodeType === 1){	// element
						this._addIdSuffix(child, suffix, reset, pre);
					}
				}
			}
		}
	},
	getGlobalResource: function(id){
		return window[id];
	},
	format: function(method, value){
  		if(!method || typeof method === 'undefined' || method === ''){
  			return value;
  		}
		var formatter = this[method.value];
		if(!formatter){
			console.error($M.localize('messages', 'mxapibase', 'Invalidformatdefinedfor0', [this.id]));
			return value;
		}
		return formatter.call(this, value);
	},
	createAttrArrayFromRecords : function(array,attribute,formatFunction) {
		var returnArray = [];
		if (array !== null) {
			for (var i = 0; i < array.length;i++) {
				var val = array[i][attribute];
				if (formatFunction) {
					val = formatFunction(val);
				}
				returnArray.push(val);
			}
		}
		return returnArray;
	},
	/**
	 * Hide Card based on passed in element.
	 * Card will hide, but will reload if necessary when refreshed and refetched from server.
	 */
	hideCard : function(context, e, dataSetId){
		var target = '';
		if(e.currentTarget!==null){
			target = e.currentTarget;
		} else {
			target = e.target;
		}
		var card = this.findCard(target);
		if(card){
			var originalHeight = $j(card).height();
			$j(card).css({'height':originalHeight+'px'});
			this.async(function(){
				$j(card).css({'transition':'.5s ease'});
				$j(card).css({'height':'0px','transform':'scale(.01)'});
				var ironlist = $M.findElementParent(card,'IRON-LIST');
				this.async(function(){
					if(e.model){
						$j(card).css({'transition':'none'});
						$j(card).css({'height':originalHeight+'px','transform':'scale(1)'});
						//context.splice(dataSetId, e.model.index, 1);
						if(ironlist){
							ironlist.notifyResize();
						}
					}
					else {
						$j(card).css({'display':'none'});
						if(ironlist){
							ironlist.notifyResize();
						}
					}
				},300);	
			}, 10);

		}
	},
	/**
	 * Find card based on passed in child element.
	 * Traverses up the card to find cardborder, which is the parent level of the card.
	 */
	findCard : function(element){
		var parent = element.parentNode;
		while (parent!==null && !$j(parent).hasClass('cardborder')){
			parent = parent.parentNode;
		}
		return parent;
	},
	/**
	 * Find parent of element based on passed in searchType
	 * Traverses up the card to find element of type searchType.
	 */
	findElementParent : function(element, searchType){
  		var parent = element.parentNode;
  		var typeArray = searchType.split('||');
  		while (parent!==null && !this.arrayContains(typeArray, parent.tagName)){
			parent = parent.parentNode;
		}
		return parent;
	},
	/**
	 * Display common Not Available (N/A) localized label.
	 */
	getNoDataString : function(){
		return this.noDataString;
	},
	/** 
	 * Get currencycode to use in labels
	 */
	getCurrencyCode: function(){
		var baseCurrency = '';
		if($M.getMaxauth() && $M.getMaxauth().whoami){
			baseCurrency = $M.getMaxauth().whoami.baseCurrency;
		}
		return baseCurrency;
	},
	hideKeyboard: function(currentFocusElement, newFocusElement) {
		if(this.screenInfo.device === 'desktop'){ //does not apply to desktops
			return;
		}
		if(!newFocusElement){
			newFocusElement = currentFocusElement;
		}
		currentFocusElement = $j(currentFocusElement);
	    currentFocusElement.attr('readonly', 'readonly');
	    currentFocusElement.attr('disabled', 'true');
        currentFocusElement.blur();
	    setTimeout(function() {
	        currentFocusElement.removeAttr('disabled');
	        newFocusElement.focus();
	        // Remove readonly attribute after keyboard is hidden.
	        currentFocusElement.removeAttr('readonly');
	    }, 100);
	},
	
	/** inner tpae app lost its session so log out the user **/
	_iframeLostSession: function(){
		this.toggleWait(true);
		this._forceLogout(this.localize('uitext','login','session_timeout'));
	},
	
	_forceLogout: function(message){
		if (this.login){
			if (!this.isBotC()){
				this.login._clearForm();
				this.login.toggleLoading(false);
				this.toggleWait(false);
				if(message){
					this.login.showMessage(message);	
				}
				else{
					this.login.showMessage('unknown_error');	
				}
				if(this.login.$$('#message')){
					localStorage.setItem('loginMessage',HTMLEncoder.sanitize(this.login.$$('#message').label));
				}
			}
			this.login.$.authenticator.logout();
		}
	},
	/**
	 * create heard and set the guestid / apikey when it is necessary
	 *
	 */
 	createHeaders: function(language, contentLocalized, apiCacheKey){
	    var headers={};
	    
	    headers['x-public-uri'] = $M.getXPublicUri();
	    
	    	
	    if(language!==undefined && language!==null){
	    		
	    	headers['Accept-Language'] = language;
	    }
		
		if(contentLocalized)
		{
			headers['content-localized'] = '1';
		}
		
		
		if(apiCacheKey)
		{
			let apikey =  $M.getApiCacheKey();
			
			if(apikey!==undefined && apikey!==null )
			{
				headers['apicachekey'] = apikey;
			}
		}
		
        $M.addGuestParams(headers);
        return headers;
	},
	
	
	loadResources: function(){
		var context = this;
		if(this.login && this.login.toggleLoading){
			this.login.toggleLoading(true);
		}
		if(this.requiredBundles.messages === 'login'){ //login page
			this.unloadedBundles.login = this.resolveUrl('..')+'maximo-login/resources.js';
		}
		else if (!this.requiredBundles || this.requiredBundles.length === 0){
			//do nothing
			console.error('Error in loadResources Error: No requiredBundles');
			this._forceLogout();
		}
		else {
			Object.keys(this.requiredBundles).forEach(function(type){
				var messageGroups = context.requiredBundles[type].join(',');
				if(messageGroups.trim().length > 0){
					context.unloadedBundles[type] =$M.configureURLContext( $M.getMaxauth().baseUri+'/oslc/'+type+'?groups='+messageGroups);
				}
			});
		}
		Object.keys(this.unloadedBundles).forEach(function(key){
			var url = context.unloadedBundles[key];

            var headers = $M.createHeaders(context.lang);
            headers['Cache-Control']='No-Cache';
            $j.ajax({
				url: url,
				resourceType: key,
				headers: headers,
				data: {
					format: 'text'
				},
				error: function(jqXHR, textStatus, errorThrown ) {
					sessionStorage.removeItem('workScapeConfiguration');
					context.unloadedBundles = {};
          			
          			//GUEST USER VERIFICAR
					console.log(errorThrown);
					if(context.login){
						context.login._clearForm();
						context.login.showMe();
						context.login.toggleLoading(false);
						context.toggleWait(false);
						if(jqXHR.status !== 401){
							context.login.showMessage('resource_error');	
						}
						context.login.toggleLoading(false);
					}
				},
				
				dataType: 'json',
				success: function(data, textStatus, jqXHR) {
					//if(data[$M.lang] && data[$M.lang][this.groupNames]){
						//data = data[$M.lang][this.groupNames];
					//}
					var req = this;
					Object.keys(data).forEach(function(groupName){
						if(groupName && data[groupName]){
							data[groupName]._fetchDate = (new Date()).getTime();
							var storeData = data[groupName];
							if(storeData.label && Object.keys(storeData).length === 2){
								storeData = storeData.label;
							}
							context._storeResources(req.resourceType, groupName, storeData);						
						}
					});
					var types = Object.keys(JSON.parse(sessionStorage.getItem('workScapeConfiguration')).requiredResources);
					types.forEach(function(type){
						context.requiredBundles.messages.forEach(function(bundle){
							if(context.resources.strings[type] && !context.resources.strings[type][bundle]){
								context._storeResources(type, bundle, {'NOGROUP':'NO DATA RETURNED FOR REQUESTED GROUP'});
							}
						});
					});
					delete context.unloadedBundles[this.resourceType];
					if(context.bundlesLoaded()){
						if(this.login && this.login.toggleLoading){
							context.login.toggleLoading(false);
						}
						context._loadLicenses();
					}
				},
				type: 'GET'
			});
		});
	},
	bundlesLoaded: function(){
		return !this.unloadedBundles || Object.keys(this.unloadedBundles).length === 0;
	},
	
	_loadLicenses(){
		var context = this;

        var headers =  $M.createHeaders(context.lang); 
        headers['Cache-Control']='No-Cache';
   		 $j.ajax({
      	    url: $M.configureURLContext($M.getMaxauth().baseUri+'/oslc/licenseinfo'),
			headers: headers,
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				sessionStorage.removeItem('licenses');
               //GUEST USER VERIFICAR
				console.log(errorThrown);
				if(context.login){
					context.login._clearForm();
					context.login.showMe();
					context.login.toggleLoading(false);
					if(jqXHR.status !== 401){
						// TODO: Create message
						context.login.showMessage(context.localize('uitext', 'mxapibase', 'license_error'));	
					}
				}
				context.toggleWait(false);
				
			},
			dataType: 'json',
			success: function(data, textStatus, jqXHR) {
				context._storeLicenses(data);
				context._loadSigoptions();
			},
			type: 'GET'
		});
	},
	_loadSigoptions(){
		var context = this;
		var headers =  $M.createHeaders(context.lang); 
		headers['Cache-Control']='No-Cache';
		$j.ajax({
			url: $M.configureURLContext($M.getMaxauth().baseUri+'/oslc/permission/allowedappoptions'),
			headers: headers,
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				sessionStorage.removeItem('options');
         //GUEST USER VERIFICAR
				console.log(errorThrown);
				if(context.login){
					context.login._clearForm();
					context.login.showMe();
					context.login.toggleLoading(false);
					if(jqXHR.status !== 401){
						// TODO: Create message
						context.login.showMessage(context.localize('uitext', 'mxapibase', 'sigoptions_error'));	
					}
				}
				context.toggleWait(false);
			},
			dataType: 'json',
			success: function(data, textStatus, jqXHR) {
				// Add _BOTC_ to list of sigoptions if it is installed.
				if(context.isBotC()){
					data._BOTC_ = 1;
				}
				//get permissions specific to the workcenter
				var requestedWorkscape = context.newWorkscape.toUpperCase();
				var permissions = data[requestedWorkscape]; 
				if(permissions){
					Object.keys(permissions).forEach(function(member){
						data[member] = permissions[member];
					});
				}
				context._storeSigoptions(data);
				context._loadAllToursForUser();
				
			},
			type: 'GET'
		});
	},
	/**
	 * Load all tours for the user, run the default one if it exists
	 */
	_loadAllToursForUser: function(){
		var context = this;
		var maxauth = $M.getMaxauth();
        var headers =  $M.createHeaders(context.lang);
        headers['Cache-Control']='No-Cache';
        $j.ajax({
			url:$M.configureURLContext( maxauth.baseUri+'/oslc/mxtour/gettrackdata?userid='+maxauth.username),
			headers: headers,
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
       //GUEST USER VERIFICAR
				
				console.log(errorThrown);
				if(context.login){
					context.login._clearForm();
					context.login.showMe();
					context.login.toggleLoading(false);
					if(jqXHR.status !== 401){
						// TODO: Create message
						context.login.showMessage(context.localize('uitext', 'mxapibase', 'tours_error'));	
					}
				}
				context.toggleWait(false);
				context._loadWorkscapeAfterTours(); //continue processing if tour load fails
			},
			dataType: 'json',
			success: function(result, textStatus, jqXHR) {
				context._loadWorkscapeAfterTours();
				context._userToursVisited=result;
			},
			type: 'GET'
		});
	},
	/**
	 * Has the tour for this path already been run by this user.
	 * @param String tour
	 */
	_hasVisited: function(path){
		return this._userToursVisited.some(function(el) {
		    return path.toUpperCase() === el.path;
		});
	},
	/**
	 * Has the tour already been run by this user.
	 * @param String tour
	 */
	wasTourRun: function(tourId){
		//tourId += $M.currentWorkscape; //requires current workcenter id
		return this._userToursVisited.some(function(el) {
		    return tourId.toUpperCase() === el.tourid;
		});
	},
	/**
	 * Register in the database that an app, subpath, and/or tour was visited by this user.
	 * @param {String} path is required
	 * @param {String} subpath is optional
	 * @param {String} tourid is optional
	 * @param {String} action is optional (values are: register, clear)
	 **/
	updateDBForVisit: function(path,subpath,tourid, action){
		var actionName = (action?action:'register')+'usage';
		var context = this;
		var urlString = '?path='+path;
		if(subpath !== undefined){
			urlString = urlString + '&subpath='+subpath;
		}
		if(tourid !== undefined){
			urlString = urlString + '&tourid='+tourid;
		}
		
		var headers =  $M.createHeaders(context.lang);
		headers['Cache-Control']='No-Cache';
		$j.ajax({
			//This is the first time this user has visited this app, show tour and update table to note the tour has been shown
			url: $M.configureURLContext($M.getMaxauth().baseUri+'/oslc/mxtour/'+actionName+urlString),
			headers: headers,
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
                //GUEST USER VERIFICAR
				console.log(errorThrown);
				if(context.login){
					context.login._clearForm();
					context.login.showMe();
					context.login.toggleLoading(false);
					if(jqXHR.status !== 401){
						// TODO: Create message
						console.error(context.localize('uitext', 'mxapibase', 'tours_error'));	
					}
				}
				context.toggleWait(false);
				
			},
			dataType: 'text',
			success: function(result, textStatus, jqXHR) {
				if(action==='clear'){
					context.removeUserTourVisits(path,tourid);
				}
			}, 
		});
	},
	
	removeUserTourVisits: function(path,tourid){
		var tempTours = [];
		this._userToursVisited.forEach(function(tour){
			//Will always have the path (ie workscape)
			if(path.toUpperCase() !== tour.path.toUpperCase()){
				//If tourid was specified, check that too
				if(tourid){
					if(tourid.toUpperCase() !== tour.tourid.toUpperCase()){
						tempTours.push(tour);
					}
				}
				else{
					tempTours.push(tour);
				}
			}
		});
		this._userToursVisited = tempTours;
	},	

	/**
	 * Persist the fact that an admin user has logged in and seen tour info.
	 */
	markAdminVisited: function(page) {
		this.updateDBForVisit(page,null,'firstadminwelcome');
	},
	/*
	 * Checks if this is an admin user and if this is the first admin to log into the system
	 */
	_setFirstAdminVisit: function(me){
		
		var deferred = $j.Deferred();
		var context = this;

		if(me.workcenters.administrator === undefined){
			deferred.resolve(); //not admin, so just return false
		}
		//Assume its not.  Don't want to hit this twice.  If we dont set it to something here,
		//when this method gets hit a second time it will refire request if first request didn't return yet
		context._isFirstAdminVisit =  false;
       
        var headers =  $M.createHeaders(context.lang);
        headers['Cache-Control']='No-Cache';

		$j.ajax({
			//strip off the '/' prefix of the route.  That seems to give the QBE mbo functionality on the server a problem and ignores the value
			url: $M.configureURLContext($M.getMaxauth().baseUri+'/oslc/mxtour/gettrackdata?path='+(context.currentWorkscape)+'&tourid=firstadminwelcome'),
			headers: headers,
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
       			//GUEST USER VERIFICAR
				console.log(errorThrown);
				if(context.login){
					context.login._clearForm();
					context.login.showMe();
					context.login.toggleLoading(false);
					if(jqXHR.status !== 401){
						// TODO: Create message
						context.login.showMessage(context.localize('uitext', 'mxapibase', 'tours_error'));
						return false; //error condition, so return false
					}
				}
				context.toggleWait(false);
			},
			dataType: 'json',
			success: function(result, textStatus, jqXHR) {
				if(result.length===0){ //if its been visited already, we don't want to show again
					context._isFirstAdminVisit =  true;
					//update database to notify an admin has visited
					context.markAdminVisited('WELCOME');
				}
				else{
					var wizardFound = false;
					for (var i = 0; i < result.length; i++){
						if(result[i].path === 'WIZARD'){
							wizardFound = true;								
							if (result[i].subpath !== 'COMPLETE'){
								context._isFirstAdminVisit =  true;
								$M.wizardStep=result[i].subpath;
							}
						}
					}
					if (wizardFound === false){
						context._isFirstAdminVisit =  true;
						$M.wizardStep='0';
					}
				}
				deferred.resolve();
			},
			type: 'GET'
		});
		return deferred;
	},
	/**
	 * Fetches the server date and time in iso 8601 format.
	 * @return Promise containing object of date/times base on datetime format defined
	 * @return iso : "2017-10-26T18:15:35-04:00"
	 * @return time : "6:15:35 pm"
	 * @return datetime : "10/26/17 6:15:35 pm"
	 * @return date : "10/26/17"
	 */
	getServerDateTime : function(){
		var context = this;
		var deferred = $j.Deferred();
		$j.ajax({
			url:$M.configureURLContext( context.getMaxauth().baseUri+'/oslc/datetime'),
			headers: {
			    'Accept-Language': context.lang,
				'x-public-uri' : context.getXPublicUri()
			},
			data: { 
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				console.log(errorThrown);
				context.toggleWait(false);
				return deferred.reject();
			},
			dataType: 'json',
			success: function(data, textStatus, jqXHR) {
				var dateTimeFormatValues = {'iso':data.dtiso, 'datetime':data.dt, 'time':data.t, 'date':data.d};
				return deferred.resolve(dateTimeFormatValues);			
			},
			type: 'GET'
		});
		return deferred;
	}, 	
	_loadLookupsError: function(e){
		console.error('Unable to load lookup definitions.');
	},
	_loadLookups: function(e){
		this._lookups = e.detail.response; 
	},
	
	getDefaultTourId: function(){
		var workScapeConfiguration = JSON.parse(sessionStorage.getItem('workScapeConfiguration'));
		if(workScapeConfiguration && workScapeConfiguration.tours){
			return workScapeConfiguration.tours.default;
		}
	},
	
	_loadWorkscape: function(){
		this._loadAllToursForUser();
	},
	
	_loadWorkscapeAfterTours: function(){
		var context = this;
		this._updateHeaderLabels();
		this.requestedWorkCenter = context.newWorkscape;
		context.noDataString = context.localize('uitext', 'mxapibase', 'NotEntered');
		context._workcenterReady(false);
// not used until value tours
//		var workScapeConfiguration = JSON.parse(sessionStorage.getItem('workScapeConfiguration'));
//		if(workScapeConfiguration && workScapeConfiguration.tours){
//			//If this is a demo user, we always want to show the tour
//			if(context.isDemoUser() || workScapeConfiguration.tours.default){
//				context._showDefaultTour = true;
//			}
//		}
		if(this.getDefaultTourId()){
			context._showDefaultTour = true;
		}

		this.async(function(){
			Polymer.Base.importHref('script/workscape/workscape-'+context.newWorkscape+context.vulcanizedExtension+'.html', function(e) {
				if(context.workScape){
					context.workScape._readyForUser = false;
				}
				if(context.login){
					context.login.toggleLoading(false);
				}
				context.toggleWait(true);
				$j('workscape-'+context.currentWorkscape).remove();
				context.currentWorkscape = context.newWorkscape;
				context.collections = {};
				context.components = {};
				context.elementCounts = {};
				context._eventSubscribers = {};
				var ws = Polymer.Base.create('workscape-'+context.newWorkscape, {'id':context.newWorkscape});
				Polymer.dom($j('body')[0]).appendChild(ws);
				context.async(function(){
					if(context.login){
						context.login.hideMe();
					}
					
					if (!this._wasRefreshed()){
						sessionStorage.setItem('default-route', JSON.stringify(this.subroute));
					}
					if(performance.navigation.type ===1){
						this.subroute=JSON.parse(sessionStorage.getItem('default-route'));
						sessionStorage.setItem('default-route', JSON.stringify(this.subroute));		
					}
					this.applySubRoute(this.subroute);

					var excludedNPSWorkscapes = ['welcome', 'selfservice'];
					if(typeof(isSurveyable) === typeof(Function) && excludedNPSWorkscapes.indexOf(context.currentWorkscape) === -1){
						isSurveyable(context);
					}
					
					if(!context._wasRefreshed()){
						trackAnalyticsPageview(context.currentWorkscape, 'Workcenter ' + context.currentWorkscape);
					}

					var workScapeConfiguration = JSON.parse(sessionStorage.getItem('workScapeConfiguration'));
					if(!workScapeConfiguration.delayedLoad){
						context.async(function(){
							context._workcenterReady(true);
						});
					}
					$j('app-wait').attr('hidden',true);
				});
			}, function(e) {
				context._workcenterReady(true);
				this.async(function(){
					$M.alert('Error - Invalid Route. '+context.newWorkscape + ' was not found.');	
				});
			});
		});
	},

	/*
	 * Allows individual workcenters to notify that they have loaded and are ready for interaction.
	 * * bypassFlag is flag for not having toggle
	 */
	_workcenterReady: function(ready,bypassFlag){
		if(this.workScape && this.workScape._readyForUser === false && ready && (ready === true || ready.detail === true)){
			this.workScape._readyForUser = true;
			this.publishEvent('workcenter-ready');
			var workScapeConfiguration = JSON.parse(sessionStorage.getItem('workScapeConfiguration'));
			var appPath = (this.get('route.path')).substring(1).split('/')[0];
			var defaultTour;
			//clear hashOverride
			sessionStorage.removeItem('hashOverride');
			if(workScapeConfiguration && workScapeConfiguration.tours){
				defaultTour = workScapeConfiguration.tours.default;
			}
			if(this._showDefaultTour && defaultTour && appPath && !this._hasVisited(appPath)){
				this._blockWait = false;
				this.showTour(defaultTour, true);
				return;
			}
		}
		this._blockWait = !ready;
		if(!bypassFlag){
			this.toggleWait(!ready);
		}

	},
		
	/*
	 * Adds a tour session storage for test purposes. Does not commit to database.
	 */
	addTestTour: function(tourId, tour){
		if(tour){
			if(typeof tour === 'string'){
				tour = JSON.parse(tour);
			}
			var toursJSON = sessionStorage.getItem('application-tours');
			if(!toursJSON){
				toursJSON = '{}';
			}
			var tours = JSON.parse(toursJSON);
			tours[this.currentWorkscape+'-'+tourId] = tour;
			sessionStorage.setItem('application-tours', JSON.stringify(tours));
		}
	},
		
	/**
	 * Run the tour.
	 * @param String tourId - optional.  Id of the tour to run.
	 * @param Boolean isDefault - optional.  Is this atempting to run a default tour.
	 */
	showTour: function(tourId, isDefault){
		this.$.istourenabled.fetchProperty('mxe.tour.enabled');
		var context=this;
		var istourdisabled = JSON.parse(sessionStorage.getItem('istourdisabled'));
		if(istourdisabled.length>0){
			if(context.isTourDisabled){
				$M.toggleWait(false);
				return false;
			}
			var key = $M.getMaxauth().whoami.loginUserName+'_'+context.currentWorkscape.toUpperCase();
			var tour = istourdisabled.filter(function (el) {
			    return (Object.keys(el)[0] === key);
			});
			
			if(tour.length===0){
				this._istourdisabledresult(tourId, isDefault);
				
			}else{
				if(tour[0][key] && !context.showTourManual){
					$M.toggleWait(false);
					return false;
				}else{
					context.showTourData(tourId, isDefault);
				}
			}
			
		}else{
			this._istourdisabledresult(tourId, isDefault);
		}
	},
	
	_storeResources: function(type, groupName, data){
		var resources = JSON.parse(sessionStorage.getItem('resources'));
		if(!resources.strings[type]){
			resources.strings[type] = {};
		}
		resources.strings[type][groupName] = data;
		sessionStorage.setItem('resources', JSON.stringify(resources));
		if(!this.resources.strings[type]){
			this.resources.strings[type] = {};
		}
		this.resources.strings[type][groupName] = data;
	},
	_storeLicenses: function(data){
		sessionStorage.setItem('licenses', JSON.stringify(data));
	},
	_storeSigoptions: function(data){
		sessionStorage.setItem('options', JSON.stringify(data));
	},
	_setLocale: function(locale){
		this.locale = locale.toLowerCase();
		var split = locale.includes('_')?locale.split('_'):locale.split('-');
		var lang = split[0];
		if(lang === 'ar' || lang === 'he'){
			this.dir = 'rtl';
			this.skin+=' rtl';
			document.dir = 'rtl';
		}
		this.locale = locale;
		this.lang = lang;
		document.getElementsByTagName('html')[0].setAttribute('lang',lang);
	},
	_loadResources: function(newValue){
		if(newValue!==null){
			if(this.demo){
				this._loadWorkscape();
				return;
			}
			this.requiredBundles = newValue;
			if(!this.requiredBundles){
				this.requiredBundles = {};
			}
			if(!this.requiredBundles.uitext){
				this.requiredBundles.uitext = [];
			}
			if(this.requiredBundles.uitext.indexOf('mxapibase')===-1){
				this.requiredBundles.uitext.push('mxapibase');
			}
			if(this.requiredBundles.uitext.indexOf('mxapitour')===-1){
				this.requiredBundles.uitext.push('mxapitour');
			}
			if(this.requiredBundles.uitext.indexOf('mxapiwelcome')===-1){
				this.requiredBundles.uitext.push('mxapiwelcome');
			}
			if(this.requiredBundles.uitext.indexOf('mxapicomponent')===-1){
				this.requiredBundles.uitext.push('mxapicomponent');
			}
			if(this.requiredBundles){
				var loaded = true;
				var resources = JSON.parse(sessionStorage.getItem('resources'));
				var context = this;
				if(resources){
					Object.keys(context.requiredBundles).forEach(function(key){
						context.requiredBundles[key].forEach(function(bundle){
							if(!resources.strings[key] || !resources.strings[key][bundle]){
								loaded = false;
							}
						});
					});
				}
				if(loaded){
					$M.resources = resources;
					context._loadSigoptions();
				}
				else {
					this.loadResources();
				}
			}
			else {
				this._loadWorkscape();
			}
		}
	},
	resources: { //filled in by loadResources
		strings : {
		}
	},
	checkSession: function(error){
		var errorCodes = [401,403];
		for (var i = 0; i < errorCodes.length; i++){
			if(error.detail.request.status === errorCodes[i]){
				$M.workScape.returnToLogin();
				return false;
			}
		}
		return true;
	},
	_changeWorkCenter: function(workcenter, properties){
		this.toggleWait(true);
		var workscapeConfiguration = sessionStorage.getItem('workScapeConfiguration');
		sessionStorage.removeItem('workScapeConfiguration');
		if(!this.loadWorkscape(workcenter, properties)){
			sessionStorage.setItem('workScapeConfiguration', workscapeConfiguration);
			this.toggleWait(false);
		}
	},
	
	_loadConfigurationData: function(workscape, login){
		var context = this;
		var configuration = sessionStorage.getItem(workscape+'Configuration');
		if(configuration){
			context.setConfiguration(JSON.parse(configuration));
			return;
		}
		var configURL = this.resolveUrl('../../workscape/configuration/'+workscape+'.json');
		$j.ajax({
			url: configURL,
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				if(jqXHR.error().status===404){
					context.setConfiguration();
				}
				else {
					console.error(errorThrown.message);
					context._forceLogout();
				}
			},
			dataType: 'json',
			success: function(data, textStatus, jqXHR) {
				context.setConfiguration(data);
			},
			type: 'GET'
		});	
	},
	
	loadWorkscape: function(workscape, properties){
		if(!this.demo && !this.hasAccessToWorkscape(workscape)){
			return false;
		}
		var workscapeConfiguration = JSON.parse(sessionStorage.getItem('workScapeConfiguration'));
		this.setNewWorkscape(workscape);
		var requiredResources;
		if (properties){
			sessionStorage.setItem('workScapeProperties', JSON.stringify(properties));
		}
		if(workscapeConfiguration && workscapeConfiguration.workscapeId === workscape){
			requiredResources = workscapeConfiguration.requiredResources;
			if(!requiredResources){
				requiredResources = [];
			}
			this.vulcanizedExtension = workscapeConfiguration.vulcanizedExtension?workscapeConfiguration.vulcanizedExtension:'';
			if(!this.requiredResources){
				this.requiredResources = requiredResources;
			}
			if(requiredResources.length!==0){
				this.toggleWait(false);
				return true;
			}
		}
		if(!this.initallyLoaded){
			this.toggleWait(false);
		}
		this.initallyLoaded = true;
		if(this.login){
			this.login.toggleLoading(true);
		}
		var context = this;
		var login = this.login;
		var welcomeConfiguration = sessionStorage.getItem('welcomeConfiguration');
		if(welcomeConfiguration){
			context._loadConfigurationData(workscape, login);
		}
		else {
			var configURL = context.resolveUrl('../../workscape/configuration/welcome.json');
			$j.ajax({
				url: configURL,
				data: {
					format: 'text'
				},
				error: function(jqXHR, textStatus, errorThrown ) {
					if(jqXHR.error().status===404){
						context.setConfiguration();
					}
					else{
						console.error(errorThrown.message);
						context._forceLogout();
					}
				},
				dataType: 'json',
				success: function(data, textStatus, jqXHR) {
					sessionStorage.setItem('welcomeConfiguration', JSON.stringify(data));
					if(workscape === 'welcome'){
						context.setConfiguration(data);
						sessionStorage.setItem(workscape+'Configuration', JSON.stringify(data));
					}
					else {
						context._loadConfigurationData(workscape, login);
					}
				},
				type: 'GET'
			});
		} 
		return true;
	},
	/** Get all common defined actions. These contain icon, event, label */
	getCommonActions: function(){
		var actions = this.workScape.commonActions;
		if(actions.localized===false){
			for (var key in actions) {
				if (actions.hasOwnProperty(key)) {
					var action = actions[key];
					if(action.label){
						action.label = this.localize('uitext', 'mxapibase', action.label);
					}
				}
			}
			actions.localized = true;
		}
		return actions;
	},
	setNewWorkscape: function(workscape){
		this.currentWorkscape = this.newWorkscape;
		this.newWorkscape = workscape;
	},
	setConfiguration: function(configData){
		if(!configData){
			configData = {'requiredResources':{}};
		}
		this.vulcanizedExtension = configData.vulcanizedExtension?configData.vulcanizedExtension:'';
		configData.vulcanizedExtension = this.vulcanizedExtension;
		configData.workscapeId = this.newWorkscape;
		sessionStorage.setItem('workScapeConfiguration', JSON.stringify(configData));
		var login = this.login;
		var context = this;
		var maxauth = this.getMaxauth();
		if(maxauth && maxauth.baseUri && !$M.demoMode){
      var configURL = $M.configureURLContext(maxauth.baseUri + '/oslc/appcfg/'+this.newWorkscape);

      var headers =  $M.createHeaders(context.lang);
      headers['Cache-Control']='No-Cache';

      $j.ajax({
				url: configURL,
				data: {
					format: 'text'
        },
        headers: headers,
				error: function(jqXHR, textStatus, errorThrown ) {
					if(login){
						login.showMe();
						login.toggleLoading(false);
						console.error(errorThrown.message);
						login.showMessage('unknown_error');
					}
				},
				dataType: 'json',
				success: function(data, textStatus, jqXHR) {
					context._setApplicationProperties(data);
					context.requiredResources = configData.requiredResources;
				},
				type: 'GET'
			});
		}
		else {
			context.requiredResources = configData.requiredResources;
		}
	},
	_setApplicationProperties: function(applicationProperties){
		$M.addToMaxauth('applicationProperties',applicationProperties);
	},
	
	/**
	 * Get an application property or undefined if not found
	 */
	getApplicationProperty: function(propertyName){
		var props = this.getApplicationProperties();
		if(props){
			return props[propertyName];
		}
		return undefined;
	},
	
	/**
	 * Get all system properties
	 */
	getSystemProperties: function(){
		var maxauth = $M.getMaxauth();
		if(maxauth){
			var whoami = maxauth.whoami;
			if(whoami && whoami.wcsyscfg){
				return whoami.wcsyscfg;
			}
		}
		return undefined;
	},
	
	/**
	 * Get a system property or undefined if not found
	 */
	getSystemProperty: function(propertyName){
		var sysProps = this.getSystemProperties();
		if(sysProps){
			return sysProps[propertyName];
		}
		return undefined;
	},
	
	/**
	 * Get all application properties
	 */
	getApplicationProperties: function(){
		var maxauth = $M.getMaxauth();
		if(maxauth && maxauth.applicationProperties){
			return maxauth.applicationProperties;
		}
		return undefined;
	},
	/**
	 * Get all sigoptions
	 */
	getSigoptions: function(){
		if(!sessionStorage.options){
			return null;
		}
		return JSON.parse(sessionStorage.options);
	},
	/**
	 * Get licenses
	 */
	getLicenses: function(){
		if(!sessionStorage.licenses){
			return undefined;
		}
		return JSON.parse(sessionStorage.licenses);
	},	
	hasAccessToWorkscape : function(workscape) {
		return this.getAllowedWorkscapes()[workscape] !== undefined;
	},
	getAllowedWorkscapes : function() {
		var maxauth = $M.getMaxauth();
		if(maxauth){
			var whoami = maxauth.whoami;
			if(whoami && whoami.workcenters){
				return whoami.workcenters;
			}
		}
		return {};
	},
	arrayContains: function(arr, object){
		for (var i in arr) {
			if (arr[i] === object){
				return true;
			}
		}
		return false;
	},
	arrayRemove: function(arr, object){
		var index = -1;
		while((index = arr.indexOf(object)) >=0 ){
			arr.splice(index,1);
		}
	},	
	/*
	 * Create Undo overlay
	 */
	createOverlay : function(toOverlay, message, completeCallback, undoCallback, timer, scroller, actions, noBR, classStyle,overlayId) {
		if(timer){
			var type = typeof timer;
			if(type!== 'object'){
				timer = this.undoIntervalSecs;	
			}
		}
		var createObj = {'completeCallback': completeCallback, 'undoCallback':undoCallback, 'timer':timer, 'noBR':noBR, 'classStyle':classStyle};
        return $M.showOverlay(toOverlay, message, createObj, null, null, scroller, actions,overlayId);
	},
	/*
	 * Create Question overlay which supports questions with buttons.
	 * Overlay also supports displaying (2) icons with labels and clickable actions.
	 * 
	 * @param toOverlay
	 * @param question Question String Text for question.
	 * @param buttonOne function object for button one that triggers an action when button is clicked
	 * @param buttonTwo function object for button two that triggers an action when button is clicked
	 * @param buttonOneText String Label for button one
	 * @param buttonTwoText String Label for button two
	 * @param scroller
	 * @param actions
	 * @param buttonOneIcon Icon Image #1
	 * @param buttonTwoIcon Icon Image #2
	 * @param showCancel Boolean true/false Display Cancel button
	 * @param displayVertical Boolean true/false Display layout horizontal(true) or vertical(false)
	 */
	questionOverlay : function(toOverlay, question, buttonOne, buttonTwo, buttonOneText, buttonTwoText, scroller, actions, buttonOneIcon, buttonTwoIcon, showCancel,displayVertical) {
		var qnObject = {'buttonOne': buttonOne,'buttonTwo':buttonTwo,'buttonOneText':buttonOneText,'buttonTwoText':buttonTwoText,'buttonOneIcon':buttonOneIcon,'buttonTwoIcon':buttonTwoIcon,'showCancel':true,'message':question};
        var overlay = $M.showOverlay(toOverlay, question, null, qnObject, displayVertical, scroller, actions);	
        return overlay;
	},	
	
	/**
	 * Add Listener to button on overlay.
	 */
	_registerButtonListener : function(buttonDiv,button,remove,overlay,toOverlay,buttonOverlay){
		buttonDiv.addEventListener('click', function(e) {
			if(remove === undefined || remove === true){
				overlay.remove();
				if(buttonOverlay){ //if buttonOverlay exists
					buttonOverlay.remove();					
				}
				toOverlay.overlay  = null;
			}
			if (button) {
				button();
			}
			
		});
	},
	
	/**
	 * Overlay button generator
	 */
	_generateButton : function(button,icon,buttonText,overlayChild,id,buttonAction,remove, overlay, toOverlay, buttonlayer,displayVertical){
		
		var layerFlexDir='column';
		var buttonFlexDir='row';
		
		var buttonInnerImageLib = Polymer.Base.create('div', {'id':button+'IconInnerImgLib'+id});
		var buttonIconDiv = Polymer.Base.create('div', {'id':button+'iconDiv'+id});
		var buttonLabelDiv = Polymer.Base.create('div', {'id':button+'labelDiv'+id});
		var buttonOuterDiv = Polymer.Base.create('div', {'id':button+'IconOuterDiv'+id});
		var iconImgDiv = Polymer.Base.create('div', {'id':button+'iconImgDiv'+id});
		
		if(displayVertical){ //vertical layout
			buttonInnerImageLib = Polymer.Base.create('maximo-imglib', {'id':button+'IconInnerImgLib'+id, 'padding': '10px', 'noimageicon':icon});		
			$j(buttonInnerImageLib).find('iron-icon')[0].style.color='#4178be';
			buttonLabelDiv.style = 'white-space:normal;';
			buttonOuterDiv.style.display = 'flex';
			buttonOuterDiv.style.justifyContent = 'center';
			buttonOuterDiv.style.paddingTop = '10px';
			buttonOuterDiv.style.alignItems = 'baseline';
			buttonIconDiv.appendChild(buttonInnerImageLib);
		} else { //horizontal layout
			layerFlexDir='row';
			buttonFlexDir='column';	
			buttonInnerImageLib = Polymer.Base.create('maximo-imglib', {'id':button+'IconInnerImgLib'+id, 'width':'50px', 'height':'50px', 'style':'color:#fff', 'noimageicon':icon});
			$j(buttonInnerImageLib).find('iron-icon')[0].style.color='#fff';
			buttonIconDiv.style = 'width: 71px; height: 71px; border-radius: 100%; background:#4178be; border: 2px solid #4178be;';
			buttonLabelDiv.style = 'white-space:normal; width:100px;';
			iconImgDiv.style.padding = '10px 0px 0px 10px';
			iconImgDiv.appendChild(buttonInnerImageLib);
			buttonIconDiv.appendChild(iconImgDiv);
		}
		
		buttonOuterDiv.style.flexDirection = buttonFlexDir;
		buttonOuterDiv.appendChild(buttonIconDiv);

		var buttonMaximoLabel = Polymer.Base.create('maximo-label', {'id':button+'maximoLabelDiv'+id, 'label':buttonText, 'style':'color: #4178be; font-size:18px'});
		$j(buttonMaximoLabel).attr('use-path-id','true');
		buttonLabelDiv.appendChild(buttonMaximoLabel);
		buttonOuterDiv.appendChild(buttonLabelDiv);
		buttonlayer.appendChild(buttonOuterDiv);	
		buttonlayer.style.flexDirection=layerFlexDir;
		buttonlayer.style.display = 'flex';
		
		this._registerButtonListener(buttonOuterDiv,buttonAction,remove,overlay,toOverlay,buttonlayer);
	},
	
	removeTextSelection: function(){
		if (window.getSelection) {
			if (window.getSelection().empty) {  // Chrome
				window.getSelection().empty();
			} 
			else if (window.getSelection().removeAllRanges) {  // Firefox
			    window.getSelection().removeAllRanges();
			}
		}
		else if (document.selection) {  // IE?
			document.selection.empty();
		}
	},
	getCSRFToken : function(){
		var csrftoken = sessionStorage.getItem('csrftoken');
		if(csrftoken === undefined || csrftoken === null){
			csrftoken = '';
		}
		return csrftoken;
	},
	openStartCenter: function(){
		//do this since we are re-using the same window and user could logout and back in with a different language from base.
		sessionStorage.removeItem('resources'); 
		document.location = this._getMaximoRecordLink('startcntr');
	},
	objectToArray: function(obj){
		return Object.keys(obj).map(x => obj[x]);
	},
	newQbe: function(qbewhere) {
		return new MaximoQbe(qbewhere);
	},
	makeSafeId: function(id){
		return id.replace(/[`~!@#$%^&*()_|+\-=?;:'",.<>\{\}\[\]\\\/]/gi, '_');
	},
	/**
	 * Redirects user to its default work center or welcome page
	 */
	showDefaultWorkCenter: function() {
		var defaultApp = this.getDefaultApplicationId(true);
		this._changeWorkCenter(defaultApp.toLowerCase());
	},
	
	/**
	 *  Is BotC installed 
	 */
	isBotC: function(){
		return this._BotC;
	},
	
	isDemoUser: function(){
		return this._demoUser;

	},
	/**
	 *  Check if this is the first time the an admin is logging in for a first time.  If so, return true and turn flag off
	 */
	isFirstAdminLogin: function() {
		var retValue = this._isFirstAdminVisit;
		if(this._isFirstAdminVisit){
			this._isFirstAdminVisit = false;	
		}
		return retValue;
	},
	isAnalyticsEnabled: function()
	{
		return this._analyticsEnabled;
	},
	
	setAnalyticsEnabled: function(enable){
		this._analyticsEnabled = enable;
	},
	
	/**
	 *  Set the x-public-uri header value
	 */
	setXPublicUri: function(uri) {
		this._xPublicUri = uri;
	},
	
	getXPublicUri: function() {
		return this._xPublicUri;
	},
  
  /**
   * 
   */
  setAPIKey: function(apikey) {
    this._apikey = apikey;
  },

  /**
   * 
   */
  getAPIKey: function() {
    return this._apikey;
  },

  /**
   * 
   */
  setGuestID: function(guestID) {
    this._guestID = guestID;
  },

  /**
   * 
   */
  getGuestID: function() {
    return this._guestID;
  },

  /**
   * 
   */
  addGuestParams: function(obj) {
    var apikey = this.getAPIKey(),
        guestID = this.getGuestID();

    if(apikey && guestID){
      obj['apikey'] = apikey;
      obj['guestid'] = guestID;
    }else{
    	
    	let maxauth = $M.getMaxauth();
    	if(maxauth && maxauth.apikey &&  maxauth.guestid ){
    	  obj['apikey'] = maxauth.apikey;
          obj['guestid'] = maxauth.guestid;
        }
    }
  },
  
  configureURLContext: function(url){
	  let  maxauth = $M.getMaxauth();
	  let newUrl=url;
	  if(maxauth && maxauth.apiContext){
		  newUrl = url.replace('/oslc/', maxauth.apiContext+'/').replace('/oslc?', maxauth.apiContext+'?');
	  }
		return newUrl;
	},
  
  
  /**
   * 
   */
  clearGuestUser: function() {
      try {
    	  this.setAPIKey(null); 
          this.setGuestID(null) ;
          this.setApiCacheKey(null) ;
          sessionStorage.removeItem('apikey');
          sessionStorage.removeItem('guestid');
          sessionStorage.removeItem('apicachekey');
     }catch (e) {
    		console.log('could not clear guest user ');
    }
    	
    	
      let maxauth = $M.getMaxauth();
      maxauth.apikey = undefined;
      maxauth.guestid = undefined;
      $M.setMaxauth(maxauth);
  },

	/**
	 * Show a lookup in a drawer
	 * @param {String} caller The object to which we will fire the maximo-lookup-value-selected event
	 * @param {String} identifier The an identifier to use in event handlers when value is chosen.
	 * @param {String} name The name of the lookup to show.
	 * @param {String} sourceHref The Href from the record on which we are getting the list of values
	 * @param {Object} lookupAction The definition of an action the lookup can perform (attributes are event, icon, label)
	 */
	showLookup: function(name, caller, identifier, sourceHref, multiSelect,additionalLookupParams,showImage, lookupAction,addFilter, addSchema,pageSize, recordCount, norecordText, toggleFilter){
		this.lookup = Polymer.Base.create('maximo-lookup-drawer', {'id':'lookup_'+name});
		if(addSchema== undefined){
			this.lookup._addSchema= true;
		}else{
			this.lookup._addSchema= addSchema;
		}
		
		if(pageSize!= undefined){
			this.lookup._pageSize= pageSize;
		} 
		
		this.lookup._name = name;
		this.lookup._identifier = identifier;
		this.lookup._caller = caller;
		this.lookup._multiSelect = multiSelect;
		this.lookup._showImage = showImage;
		this.lookup._additionalLookupParams = additionalLookupParams;
		this.lookup._lookupAction = lookupAction;
		this.lookup._sourceHref = sourceHref;
		this.lookup._addFilter = addFilter;
		this.lookup._recordCount = recordCount;
		this.lookup._norecordText = norecordText;
		this.lookup._lookupFilter = toggleFilter;
		if(caller._lookupObject && caller._lookupObject.qrCode){
			this.lookup.qrCode = caller._lookupObject.qrCode;
			this.lookup._identifier = caller._lookupObject.identifier;
		}
		var lookup = this.lookup;
		this.async(function(){
			this.workScape.openDrawer((this.dir==='rtl'?'west':'east'),lookup);
			caller.fire('maximo-lookup-drawer-opened',{id:'lookup_'+name});
		});
	},
	
	/**
	 * Hide all drawers
	 */
	hideLookup: function(){
	  var lookupCaller;
	  var lookupName;

		this.workScape.closeDrawers();
		// Store values to fire event after lookup set as null
		if (this.lookup && this.lookup._caller && 
        typeof this.lookup._caller == 'object' && this.lookup._name) {
		  lookupCaller = this.lookup._caller;
	    lookupName = this.lookup._name;  
		}

		this.lookup = null;

		if (lookupCaller && lookupName) {
		  lookupCaller.fire('maximo-lookup-drawer-closed',{id:'lookup_'+lookupName});
    }
	},
	
	/**
	 * Traverse object structure to return the attribute value
	 * Ex: location.description 
	 */
	getRelatedData: function(object, attribute){
		var objAttr = attribute.split('.');
		try {
			objAttr.forEach(function(attrLevel){
				if(!object[attrLevel] && object[attrLevel]!=0){
					throw 'notfound';
				}
				object = object[attrLevel];
			});
		}
		catch(error){
			object = '';
		}
		return object;
	},
	
	/**
	 * Set related data using dot notation to access sub elements. Value must be a string.
	 */
	setRelatedData: function(object, attribute, value){
		var keys = attribute.split('.');
		keys.forEach(function(key){
			if(typeof object[key] !== 'string'){
				object = object[key];
			}
			else {
				object[key] = value; 
			}
		});
	},
	
    /* jshint ignore:start */
	/* convert hex value to RGB. Must use full siz digit hex */
	hexToRgb: function(hex) {
		if(hex.startsWith('#')){
			hex = hex.substring(1);
		}
	    var bigint = parseInt(hex, 16);
	    var r = (bigint >> 16) & 255;
	    var g = (bigint >> 8) & 255;
	    var b = bigint & 255;
	    return r + "," + g + "," + b;
	},
    /* jshint ignore:end */
	isMobile: function(){
		//return (typeof window.orientation !== 'undefined') || (navigator.userAgent.indexOf('IEMobile') !== -1);
		var ua = navigator.userAgent;
		return (/Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini|Mobile|mobile|CriOS/i.test(ua));
	},
	/**
	 * Use to add an avent to call once and then remove it. Jquery one does not allow capture. This one does.
	 */
	once: function(element, event, callback, capture){
		element.endOnce = function(e) {
			element.removeEventListener(event, element.endOnce, capture);
			callback(e);
		};
		element.addEventListener(event, element.endOnce, capture);
	},
	killOnce: function(element, event, capture){
		element.removeEventListener(event, element.endOnce, capture);
		element.endOnce = undefined;
	},
	/*
	 * Enable/disable basic page navigation. This allows simple api so app developers don't need to know the whole list of items.
	 */
	allowPageNavigation: function(allowed){
  		var selectorArray = [
  			$M.workScape.$.headerbar, //workscape header
  			$j('.carouselController') //page carousel on mobile
  		];
  		var navbar = $j('maximo-navbar')[0];
  		if(navbar){
  			selectorArray = selectorArray.concat([
  				navbar.$.sideMenu,
  	  			navbar.$.hamburger
  	  		]); 
  		}
  		$M.toggleDisabled(selectorArray, !allowed);
  	},
  	getUserInfo: function(){
  		this.userinfo = JSON.parse(sessionStorage.getItem('userinfo'));
  		return this.userInfo;
  	},
  	
  	 /**  
	  * notify the Work Center if the enviroment was set as botc or not
	  */
  	_notifyWorkCenter: function(){
  		this.async(function(){  
  			if($M.workScape){
  				$M.workScape.fire('maximo-botc');
  			}
		}, 250);
  	},

    /*
	* Check content from welcome.json to determine if the current feature is listed and enabled
	* example: ...is="dom-if"  if="[[isFeatureEnabled()]]"...
	* @param {string} feature name to check
	*/
	isFeatureEnabled: function(feature){
		var enabled = true;
		var isFeatureSetInGlobal = false;
		if(feature){
			var welcomeConfiguration = JSON.parse(sessionStorage.getItem('welcomeConfiguration'));
			if(welcomeConfiguration && welcomeConfiguration.features && welcomeConfiguration.features.global){
				var flag = welcomeConfiguration.features.global[feature] ;
				if(flag!== undefined){
					enabled = flag;
					isFeatureSetInGlobal = true;
				}
			}
  			if(!isFeatureSetInGlobal){
  				var workcenterContext = $M.workScape.getWCContext();
  				var workcenterId = this.currentWorkscape + (workcenterContext?':'+workcenterContext:'');
	  			if(!welcomeConfiguration.features.workcenter || !welcomeConfiguration.features.workcenter[workcenterId]){ //no global features so must not be disabled
					return enabled;
				}
	  			enabled = welcomeConfiguration.features.workcenter[workcenterId][feature] === true;
  			}
		}
		return enabled;
  	},
  	
  	/*
	* Check content from welcome.json to determine if the current work center is marked as 'under-construction' 
	* example from welcome.json: "under-construction": {'workscapename":true} 
	*/
  	isWCUnderConstruction: function(){
  		var welcomeConfiguration = JSON.parse(sessionStorage.getItem('welcomeConfiguration'));
  		return welcomeConfiguration['under-construction'] && welcomeConfiguration['under-construction'][this.currentWorkscape+($M.workScape.getWCContext()?':'+$M.workScape.getWCContext():'')] === true; 
  	},
  	/**
	 * Function will display customized Dialog based on parameters
	 * 
	 * @param {Object} smallScreenData Object containing attributes based on 
 	 */
  	smallDeviceNotificationDialog: function(smallScreenData) {
  		var completeTimer;
		
  		//Set title
		var title;
		switch(smallScreenData.type){
			case $M.alerts.info:
				title= $M.localize('uitext', 'mxapisr', 'information');
				break;
			case $M.alerts.warn:
				title= $M.localize('uitext', 'mxapibase', 'warning');
				break;
			case $M.alerts.error:
				title= $M.localize('uitext', 'mxapisr', 'error');
				break;
			case $M.alerts.question:
				title= $M.localize('uitext', 'mxapiinspection', 'question');
				break;
			default:
				title= '';
				break;
		}
		smallScreenData.title = title;
    	var notifyDialog = this._showDialog(smallScreenData.parent, smallScreenData.id, smallScreenData.title, smallScreenData.message, smallScreenData.fullSize, smallScreenData.owner);
		if (smallScreenData.undoNotification){
			// set completeCallback timer
			if (smallScreenData.completeCallback){
				// do timer
				completeTimer = window.setTimeout(function() {
					if (smallScreenData.completeCallback) {
						smallScreenData.completeCallback();
					}
				}, this.undoNotificationtimeout * 1000);
			}
			// set undo button
			var undo = Polymer.Base.create('maximo-button',{'default':'true','id':notifyDialog.id+'_footer_undo','icon':'Maximo:Reset','label':this.localize('uitext', 'mxapibase', 'Undo')});
			$j('maximo-dialog').find('#footer').html(undo);
    		$j('maximo-dialog').find('#footer').css({'text-align':'center'});
    		undo.onTap = function(){
    			if (completeTimer) {
					window.clearTimeout(completeTimer);
				}
				if (smallScreenData.undoCallback) {
					smallScreenData.undoCallback();
				}
    			notifyDialog.cancel();
    			undo.listen(undo, 'tap', 'onTap');
			};
		}
	},
	
	/*
	* mark  tour as visited
	*/
  	markTourVisited : function(appName ,tourId ){
		$M.updateDBForVisit(appName, null, tourId);

		var newTour={'tourid':tourId.toUpperCase(), 'path':appName.toUpperCase(), 'userid':$M.getMaxauth().whoami.loginUserName, 'subpath':null};
		$M._userToursVisited.push(newTour);

	}, 
	
	/*
	* enable / disable default tour
	*/
	enableDefaultTour : function(flag){
		this._showDefaultTour = flag;

	}, 
	
	/** stores session id of iframe tpae for re-use **/
	_setUISessionID: function(sessionid){
		var maxauth = this.getMaxauth();
		maxauth._UISESSIONID_ = sessionid
		this.setMaxauth(maxauth);
	},
	
	/** set title of inner tpae app **/
	_setMaximoAppTitle: function(title){
		this.workScape.label = title;
	},
	
	/**
  	 * Fetch date as ISO date
  	 */
  	getISODateString : function(d) {
  	    function pad(n) {return n<10 ? '0'+n : n}
  	    return d.getFullYear()+'-'
  	         + pad(d.getMonth()+1)+'-'
  	         + pad(d.getDate())
  	},
  	
  	/*
	* Check content from welcome.json to determine if the current work center is marked as 'design-enabled' 
	* example from welcome.json: "design-enabled": {'workscapename":true} 
	*/
  	isWCDesignEnabled: function(){
  		var welcomeConfiguration = JSON.parse(sessionStorage.getItem('welcomeConfiguration'));
  		if(welcomeConfiguration){
  			return welcomeConfiguration['design-enabled'] && welcomeConfiguration['design-enabled'][this.currentWorkscape+($M.workScape.getWCContext()?':'+$M.workScape.getWCContext():'')] === true;
  		}
  		return false;
  	},
  	
  	
  	_designModeChanged: function(){
  		this.publishEvent('designer-fire-edit', {'showedit':this.inDesignMode()});
  	},
  	
  	
  	_pauseDesignMode: function(e){
  		var currentDesignMode = this.inDesignMode();
  		this._setSessionDesignMode(!e.detail);	
  		this.workScape._edit(!e.detail);
  		this.fire('design-mode-changed');
  		this.publishEvent('designer-pause', e.detail);
  		this.async(function(){ //set it back to what it should be in case user refreshes 
  			this._setSessionDesignMode(currentDesignMode);	
  		}, 100);
  		
  	},
  	
  	/**
  	 * Toggle design mode on/off and publish an event to notify any listeners
  	 */
  	_toggleDesignMode: function(e){
  		$M.toggleWait(true);	
  		var context = this;
		var newMode = (typeof e.detail === 'boolean')?e.detail:!this._getSessionDesignMode();
  		var url = this.resolveUrl('../../../context.jsp')+'?designmode='+newMode;
		$j.ajax({
			url: url,
			headers: {
			    'Accept-Language': context.lang,
			    'apicachekey':  context.getApiCacheKey(),
				'x-public-uri':  context.getXPublicUri()
			},
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				//could not toggle design mode
			},
			dataType: 'json',
			success: function(data, textStatus, jqXHR) {
				context._setSessionDesignMode(newMode);
				if(typeof e.detail !== 'boolean'){
					context.closeAllDialogs().then(function(){  // make sure all dailogs are closed
						window.location.reload();	
					});
					
				}
			},
			type: 'GET'
		});
  	},
	
  	_updateHeaderLabels: function(){
  		var maxauth = $M.getMaxauth();
  		var whoami = maxauth.whoami;
  		if(whoami && whoami.workcenters){
			Object.keys(whoami.workcenters).forEach(function(wcId, idx) {
				var lowerCaseId = wcId.toLowerCase();
	  	  		var bundle = $M._configLabels;
	  			var productKey = 'WC_!productName_'+lowerCaseId;
	  			var myProdName = $M.localize('uitext',bundle,productKey);
				if(myProdName !== productKey){//Found a configured description for this product, so use this one
					whoami.workcenters[lowerCaseId].prodName = myProdName;
		  		}
				var appKey = 'WC_!appName_'+lowerCaseId;
				var myAppDesc = $M.localize('uitext',bundle,appKey);
				if(myAppDesc !== appKey){//Found a configured description for this app, so use this one
					whoami.workcenters[lowerCaseId].description = myAppDesc;
				}
	  		});
	  		maxauth.whoami = whoami;
  		}
  		$M.setMaxauth(maxauth);
  	},
  	  	
  	loadWhoAmI: function(whoami){
  		var temp = {};
  		Object.keys(whoami.workcenters).forEach(function(wcId, idx) {
  			whoami.workcenters[wcId].hidden = false;
  			var lowerCaseId = wcId.toLowerCase(); 
  			if($M.screenInfo.size==='small' && (lowerCaseId==='datasetdesigner' || lowerCaseId==='inspectorsup' || lowerCaseId === 'weatheradmin')){ //do not allow DsD on small devices.
  				whoami.workcenters[wcId].hidden = true;
  			}
  			temp[lowerCaseId] = whoami.workcenters[wcId];
  		});
  		$M.unregisteredApps.forEach(function(app){
  			temp[app] = {apptype:'APP',description:'',hidden:true}; //used to allow a test WS
  		});
  		
  		whoami.workcenters = temp;
  		var maxauth = $M.getMaxauth();
  		maxauth.whoami = whoami;
  		var locale = '';
  		if(!maxauth.whoami.defaultLcale || maxauth.whoami.defaultLcale === ''){
  			locale = window.navigator.userLanguage || window.navigator.language;
  			maxauth.whoami.defaultLcale = locale;
  		} else {
  			locale = maxauth.whoami.defaultLcale.replace('_','-');
  		}
  		
  		if(!maxauth.whoami.baseCurrency && $M.getMaxauth().whoami && $M.getMaxauth().whoami.baseCurrency){
  			maxauth.whoami.baseCurrency=$M.getMaxauth().whoami.baseCurrency;
  		}
  		
  		if(locale.indexOf('-')===-1){
  			maxauth.whoami.defaultLcale += '-US';
  			locale = maxauth.whoami.defaultLcale;
  		}	

  		var langLocation = locale.split('-');
  		maxauth._lang = langLocation[0];
  		maxauth._country = langLocation[1];

  		if(maxauth.whoami.defaultLanguage && maxauth.whoami.defaultLanguage.length>0){
  			maxauth._lang = maxauth.whoami.defaultLanguage.toLowerCase();
  		}
  		if(maxauth.whoami.langcode && maxauth.whoami.langcode.length>0){
  			maxauth._lang = maxauth.whoami.langcode.toLowerCase();
  		}
		
		maxauth.whoami.defaultLcale = maxauth.whoami.defaultLcale;	
  		maxauth.username = maxauth.whoami.userName;
  		$M._setLocale(locale);
  		document.documentElement.lang = maxauth._lang;
  		
  		$M.setMaxauth(maxauth);
  		$M._updateHeaderLabels();
  		$M.setApiCacheKey(whoami.apicachekey);
  		trackAnalyticsLogin();
  		
  		login.personId = maxauth.whoami.personId;
  		//login.$.personcollection.refreshRecords();//Anamitra
  		$M.userInfo = whoami;
  		sessionStorage.setItem('userinfo', JSON.stringify($M.userInfo));
		if(this._isFirstAdminVisit===null){
	    	$M._setFirstAdminVisit(maxauth.whoami).then(function(){
		    	login.loadResourcesAndWorkscape();
	    	});
    	}
		else {
	    	login.loadResourcesAndWorkscape();
		}
  		moment.locale($M.locale);
    	//Localization for datepicker
    	var langData = login.datepickerLanguageData($M.locale);
    	$j.datepicker.setDefaults(langData);
  	},
  	
  	designOnlyAttributes: function(attributes,component){
		if(!component._propertySheetAttributes){
			delete attributes.collection;
			return attributes;
		}
		var designAttributes = {};
		Object.keys(attributes).forEach(function(attributeName){
			if((component._propertySheetAttributes && component._propertySheetAttributes.includes(attributeName)) || attributeName === 'hideatruntime'){
				designAttributes[attributeName] = attributes[attributeName]; 
			}
		}.bind(this));	
		return designAttributes;
	},
	
	_getSessionDesignMode: function(){
		var designMode = JSON.parse(sessionStorage.getItem('designMode'));
		if (designMode === null || designMode === undefined)
			designMode = false;
		return designMode;
	},
	_setSessionDesignMode: function(designMode){
		sessionStorage.setItem('designMode', designMode);
	},
	_tpaeLoadChange: function(newValue){
		this.toggleWait(!newValue);
	},
	/**
	 * Disable the tour for workcenter if user has skipped the same. 
	 **/
	disableTour: function(){
		var urlString = '?workcenter='+$M.$.contextAppRouter.data.workcenter;
		var context = this;
		$j.ajax({
			url: $M.configureURLContext($M.getMaxauth().baseUri+'/oslc/mxtour/disabletour'+urlString),
			headers: {
			    'Accept-Language': context.lang,
				'x-public-uri' : $M.getXPublicUri()
			},
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				console.log('Error with tours : [updateDBForVisit('+path+','+subpath+','+tourid+','+action+']');
				console.log(errorThrown);
			},
			dataType: 'text',
			success: function(result, textStatus, jqXHR) {
				
			}, 
		});
	},
	/**
     * To check whether tour is disabled or not
     */
	_istourdisabled: function(){
		var context = this;
		var deferred = $j.Deferred();
		$j.ajax({
			url: $M.configureURLContext(context.getMaxauth().baseUri+'/oslc/mxtour/istourdisabled?workcenter='+context.newWorkscape),
			headers: {
			    'Accept-Language': context.lang,
				'x-public-uri' : context.getXPublicUri()
			},
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				console.log(errorThrown);
				context.toggleWait(false);
				return deferred.reject();
			},
			dataType: 'json',
			success: function(data, textStatus, jqXHR) {
				var users = JSON.parse(sessionStorage.getItem('istourdisabled'));
				if(!(users && users instanceof Array)){
					users= [];
				}
				var info={};
				info[$M.getMaxauth().whoami.loginUserName+'_'+context.currentWorkscape.toUpperCase()]=data.disabled;
				users.push(info);
			
				sessionStorage.setItem('istourdisabled', JSON.stringify(users));
				return deferred.resolve(data);
			},
			type: 'GET'
		});
		return deferred;
	},
	/**
     * Handler for system property refresh
     */
    _handleGetTourProperty: function(e){
    	this.isTourDisabled = (e.detail==0) ? true : false;
    },
    /**
     * Capture the fire event from maximo usermenu
     */
    _showUserTour: function(e){
    	this.showTourManual = e.detail.userTour;
    },
    /**
     * Show tour Data 
     */
    showTourData: function(tourId, isDefault){
    	var context=this;
		$M.toggleWait(true);
		var appName = context.newWorkscape;
		var toursJSON = sessionStorage.getItem('application-tours');
		if(!toursJSON){
			toursJSON = '{}';
		}
		var tours = JSON.parse(toursJSON);
		var tour = tours[context.currentWorkscape+'-'+tourId]; 
		//update local copy of tours to note this tour was visited.  If the actual get fails then the db will not be updated and this will be corrected next time in.
		var newTour={'tourid':tourId.toUpperCase(), 'path':appName.toUpperCase(), 'userid':$M.getMaxauth().whoami.loginUserName, 'subpath':null};
		$M._userToursVisited.push(newTour);
		if(tour && !context.debug){
			$M.$.tourController.startTour(tour, (context.getDefaultTourId() === tourId));
			$M.toggleWait(false);
			return;
		}
		$j.ajax({
			url: $M.configureURLContext($M.getMaxauth().baseUri+'/oslc/mxtour/gettour?tourid='+tourId+'&path='+appName),
			headers: {
			    'Accept-Language': context.lang,
				'x-public-uri' : $M.getXPublicUri()
			},
			data: {
				format: 'text'
			},
			error: function(jqXHR, textStatus, errorThrown ) {
				console.log('Error with tours : Could not show tour [showTour]');
				console.log(errorThrown);
				$M.async(function(){	
					$M.toggleWait(false);
				},100);
			},
			dataType: 'json',
			success: function(result, textStatus, jqXHR) {
				if(result.tour){
					$M.async(function(){
						try{
							tour = $j.parseJSON(result.tour);
							tour.id = tourId;
							tours[context.currentWorkscape+'-'+tourId] = tour; 
							sessionStorage.setItem('application-tours', JSON.stringify(tours));
							$M.$.tourController.startTour(tour, (context.getDefaultTourId() === tourId));
						}
						catch(error){
							console.log(error+':\n'+result.tour);
						}
						$M.async(function(){
							$M.toggleWait(false);
						},100);
					},100);
				}
				else {
					$M.async(function(){
						$M.toggleWait(false);
					},100);
				}
			},
		});
    },
    /**
     * On the basis _istourdisabled() response show tour or not
     */
    _istourdisabledresult: function(tourId, isDefault){
    	var context = this;
    	this._istourdisabled().then(function(response){
			if(context.isTourDisabled){
				$M.toggleWait(false);
				return false;
			}
			
			if(response.disabled && !context.showTourManual){
				$M.toggleWait(false);
				return false;
			}else{
				context.showTourData(tourId, isDefault);
			}
		});
    },
    //Fix footer position during togglewait.
	_fixFooterPosition: function(state){
		var defaultBodyStyle = 'background: rgb(255, 255, 255); overflow: hidden auto;';
		if(state){
			var adjustHeight = ($j(window).scrollTop() > 0)?document.body.scrollHeight : window.innerHeight - $j('#workscape_footerBg').height();
			defaultBodyStyle += 'min-height:100vh;height:'+adjustHeight+'px';
		}
		$j('body').attr('style', defaultBodyStyle);
	},
	
	
	
  /**
   * Method to copy an input to the clipboard.
   */
  copyToClipboard: function (inputElement) {
      
      try {
	    if(navigator.userAgent.match(/ipad|iphone/i)){
	    	var range,selection;
	    	
	    	// save current contentEditable/readOnly status
	        var editable = inputElement.contentEditable;
	        var readOnly = inputElement.readOnly;

	        // convert to editable with readonly to stop iOS keyboard opening
	        inputElement.contentEditable = true;
	        inputElement.readOnly = true;
		   
		    range = document.createRange();
	        range.selectNodeContents(inputElement);
	        selection = window.getSelection();
	        selection.removeAllRanges();
	        selection.addRange(range);
	        inputElement.setSelectionRange(0, 999999);
	        
	        inputElement.contentEditable = editable;
	        inputElement.readOnly = readOnly;
	      }else{
	    	if (window.clipboardData && window.clipboardData.setData) {
	  	      return clipboardData.setData("Text", inputElement.value);
	  	    } else if (document.queryCommandSupported && document.queryCommandSupported("copy")) {
	  	    	inputElement.select();
	  	    }
	      }
    	  
        // Security exception may be thrown by some browsers.
        var copy = document.execCommand("copy");

        if(copy){
          $M.notify($M.localize('uitext', 'mxapibase', 'CopiedToClipboard'), $M.alerts.info);
        }

        return copy;
      } catch (ex) {
        console.warn("Copy to clipboard failed.", ex);
        return false;
      }
    
  },
  
  
}); 